# @(#)Makefile.sol	1.3 96/08/08
#
# Solaris-specific makefile for building optional native library support.
# Use this as a starting point for porting to other platforms.
#

TOP=..

# Default location of java runtime
JAVA_HOME=/opt/java

# Java runtime flags
JAVAH=$(JAVA_HOME)/bin/javah
CLASSPATH=$(TOP)/classes:$(JAVA_HOME)/classes:$(JAVA_HOME)/lib/classes.zip

# OS and machine type
OS=solaris
ARCH:sh=uname -p
OBJ=$(OS)/$(ARCH)

# Default compiler flags
CC=cc
CFLAGS=-fast -Kpic
CPPFLAGS=-I$(OS) -I$(JAVA_HOME)/include -I$(JAVA_HOME)/include/$(OS)
LDFLAGS=-G

INSTALL=/usr/sbin/install
LIBDIR=$(TOP)/lib/$(OBJ)

LIBS = $(OBJ)/libserver.so
OBJS = $(OBJ)/server.o $(OBJ)/sun_server_Server.o

all: $(LIBS)

$(OBJ)/libserver.so: $(OBJS)
	$(LINK.c) -o $@ $(OBJS)

$(OBJ)/server.o: server.c $(OS)/sun_server_Server.h
	$(COMPILE.c) -o $@ server.c

$(OBJ)/sun_server_Server.o: $(OS)/sun_server_Server.c
	$(COMPILE.c) -o $@ $(OS)/sun_server_Server.c

$(OS)/sun_server_Server.c:
	$(JAVAH) -d $(OS) -classpath $(CLASSPATH) -stubs sun.server.Server

$(OS)/sun_server_Server.h:
	$(JAVAH) -d $(OS) -classpath $(CLASSPATH) sun.server.Server

install: $(LIBS)
	$(INSTALL) -d $(LIBDIR)
	$(INSTALL) -f $(LIBDIR) $(LIBS)

clean:
	rm -rf $(OS)
	
.INIT:
	-@mkdir -p $(OBJ)
