/*
 * @(#)BBoardServlet.java	1.8 96/11/07
 *
 * Copyright (c) 1993-1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * The Java source code is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.

 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

import java.io.*;
import java.net.*;
import java.util.*;
import java.servlet.*;
import java.servlet.http.*;
import sun.server.http.HttpServletContext;

/*
 * Bulletin board servlet
 * @author  Rachel Gollub
 */
public class BBoardServlet extends FormServlet {

/*
 * This gets the information from the html form, reads the file,
 * and writes to it.
 */
public synchronized void sendResponse(HttpServletResponse res, Hashtable tab) throws IOException {

	ServletOutputStream out = res.getOutputStream();
	HttpServletContext servletContext = (HttpServletContext)getServletContext();
	String bBoardName = servletContext.getRealPath("public_html/board.html");
	RandomAccessFile fil = new RandomAccessFile(bBoardName, "rw");
	String entry = (String) tab.get("entry");
	String noentry = (String) tab.get("noentry");
	String entries[] = new String[50];
	int i;
	entries[0] = null;

        res.setContentType("text/html");

	for (i=1; i<50; i++)
        	if (fil.getFilePointer() < fil.length())
               		entries[i] = fil.readLine();
		else
			entries[i] = null;

	/* This bit, including the horrid concat line, writes to the file,
	 * replacing all \n characters with <BR>.
	 */

	if (entry != null && noentry == null) {
		fil.seek(0);
		while ((i=entry.indexOf("\n")) != -1)
			entry=entry.substring(0,i-1).concat("<BR>").concat(entry.substring(i+1,entry.length()));
		entries[0]=entry;
		fil.writeBytes(entry + "\n");
		for (i=1; i<50; i++)
			if (entries[i] != null)
				fil.writeBytes(entries[i] + "\n");
	}
	fil.close();
	BuildBoard(out, entries);
    }

/*
 * This parses the information into bulletin board entries.
 */
public void BuildBoard(ServletOutputStream out, String entries[]) throws IOException {
	int i;

	out.print("<HR>");
	for (i=0; i<50; i++)
		if (entries[i] != null) {
        		out.print(entries[i]);
			out.print("<HR>");
		}
        out.flush();
}

public String getServletInfo() {
        return "This servlet maintains a bulletin board on a server.";
}

}

