import java.io.*;
import java.util.*;
import java.servlet.*;
import java.net.InetAddress;
import java.servlet.http.*;
import sun.net.smtp.SmtpClient;
import java.servlet.html.*;

/** Simple mail servlet which processes the form and send an email.  Note: 
 * requires sun.net.smtp.SmtpClient to function.  Also note that it also
 * requires a direct internet connection (no firewalls), or a mailserver
 * running on the webserver's host machine.  To work in other situations,
 * modify the line with "java.sun.com" as the host to include a host within
 * your local network that has the ability to process incoming SMTP mail.
 * Most Unix machines are capable of this.
 * @author  Pavani Diwanji
 * @author  Jim Driscoll
 */
public class MailServlet extends FormServlet {

/**
 *  Sends email to the user specified by the form's "email" field.  This method
 *  overrides FormServlet.sendResponse(res, tab);
 *  @see java.servlet.http.FormServlet#sendResponse
 *  @param res The servlet's response.
 *  @param tab A Hashtable of the fields entered in the form.  
 */
    public synchronized void sendResponse(HttpServletResponse res, Hashtable tab)
        throws IOException
    {
        Enumeration keys;
        String key;
        String value;
	OutputStream out = res.getOutputStream();
        String line = null;
 
        res.setContentType("text/html");

	HtmlPage page = new HtmlPage("Form Reply");
	page.add("Form Reply", "H1");
	page.addTag("P");

	String name = (String) tab.get("name");
	String email = (String) tab.get("e-mail");
	boolean succeed = false;
	PrintStream ps = null;
    SmtpClient sendmail = null;
	if ((name.length() > 0) && (email.length() > 0)) {
	    try {
		    // open smtp connection
		    sendmail = new SmtpClient("java.sun.com");
	        sendmail.from("jeeves@java.sun.com");
		    sendmail.to(email);
		    // get printstream
		    ps = sendmail.startMessage();
		    succeed = true;
	    } catch (Exception e) {
		    e.printStackTrace();
			page.add("Couldn't reach you through javasoft, trying your local machine instead.  You probably are behind a firewall.");
	    }	    
		if (!succeed) {
		    try { //try again, this time, to localhost
		        // open smtp connection
		        sendmail = new SmtpClient(InetAddress.getLocalHost().getHostName());
	            sendmail.from(email);
		        sendmail.to(email);
		        // get printstream
		        ps = sendmail.startMessage();
	        } catch (Exception e) {
		        e.printStackTrace();
			    page.add("There was an error sending you mail.");
				//if we bomb this time, give up
				return;
	        }	    
		}
        
		try {
            // send headers.
		    ps.println("From: "+email);
		    ps.println("To: "+email);
		    ps.println("Subject: Thanks for using Jeeves");
		    ps.print("\r\n"); //header area delimiter
    
		    // now send data to it
		    ps.println("Hello " + name + ",");
		    ps.println();
		    ps.println("Thanks for looking at Jeeves.");
		    ps.println();
		    ps.println("- Jeeves Team.");
		    ps.println("(email was generated by MailServlet).");
	    	
		    ps.flush();
		    ps.close();
			sendmail.closeServer();
	        page.add("You will get an email thanking you for using Jeeves.");
        } catch (Exception e) {
			e.printStackTrace();
			page.add("There was an error sending you mail.");
			return;
        }


	}
	else page.add("You need to enter both name and email address");

	page.write(out);
	out.flush();
    }

    public String getServletInfo() {
	return "This mail servlet sends email thanking for downloading.";
    }

}

