/*
 * @(#)DateServlet.java	1.6 96/10/14 
 *
 * Copyright (c) 1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */
package rmiexample;

import java.servlet.*;
import java.io.*;
import java.util.Date;
import java.util.Hashtable;

import java.rmi.*;
import java.rmi.registry.*;
import java.rmi.RMISecurityManager;

import java.servlet.http.*;

/**
 * This class is a very simple demonstration of a Servlet using RMI to
 * access some backend RMI server. In this case a simple Counter server.
 * @author Freeman Murray
 * @version 1.0, 10/15/96
 */
public class CounterServlet extends GenericServlet {
    Counter counter;

    public CounterServlet() {
        // Create and install the security manager
	if (System.getSecurityManager() == null) 
            System.setSecurityManager(new RMISecurityManager());

        try {
            counter = (Counter)Naming.lookup("counter");
	    counter.reset();
        } catch (Exception e) {
	    System.out.println("bind exception");
            e.printStackTrace();
        }
    }

    public void service(ServletRequest req, ServletResponse res)
    throws ServletException, IOException
    {
        res.setContentType("text/plain");

	ServletOutputStream out = res.getOutputStream();
	try {
	    out.println(counter.inc());
	} catch (Exception e) {
	    e.printStackTrace();
	}
    }

    public String getServletInfo() {
        return "Returns a string representation of the number of times " +
		"this servlet has been accessed";
    }
}
