//package webmail.frames;

import java.awt.*;
import java.io.*;
import java.net.*;
import java.util.*;
import gjt.ImageButton;
import gjt.ImageButtonEvent;


class ComposeFrame extends Frame {
  private ImageButton sendmail, closefr;
  private Panel but_panel, header_panel, list_panel, panel;
  private Label lblMailTo, lblMailCc, lblMailBcc, lblMailFcc;
  private Label lblAttach, lblSubject, lblMsgBody, lblAliases;
  private Panel lblPanel;
  private TextField tfMailTo, tfMailCc, tfMailBcc, tfMailFcc;
  private TextField tfAttach, tfSubject, butDesc;
  private String strMailTo, strMailBcc, strMailCc, strMailFcc;
  private String strAttach, strSubject;
  private TextArea ta;
  private List aliasList1, aliasList2, aliasList3;
  private CheckboxGroup cb_group;
  private Checkbox[] checkbox;
  GridBagLayout gridbag = new GridBagLayout();
  private String[] array = null;
  private String toSend = null;
  private PrintStream out;
  private String defaultMsgBody = "";
  private String defaultSubject = "";
  private String frameAction = null;
  private Editor editor;
  private Color lblColor;

  public ComposeFrame(Editor ed, String atype, PrintStream outps) {
    super(atype + " Mail");
    frameAction = atype;
    editor = ed;
    out = outps;
    strInitialize ();
    show_frame();
  }

  public ComposeFrame(Editor ed, String atype, PrintStream outps, String default_msg, String default_subject) {
    super(atype + " Mail");
    frameAction = atype;
    editor = ed;
    out = outps;
    defaultMsgBody = default_msg;
    defaultSubject = default_subject;
    strInitialize ();
    show_frame();
  }
  
  private void strInitialize () {
    strMailTo = "";
    strMailCc = "";
    strMailBcc = "";
    strMailFcc = "";
    strAttach = "";
    strSubject = "";
  }

  public void show_frame() {
    /* Panel containing buttons to send mail etc. */
    setBackground(new Color(255, 228, 225));
    lblColor = new Color(24, 96, 0);
    but_panel = new Panel();
    but_panel.setLayout(new FlowLayout());
    but_panel.setLayout(gridbag);
    but_panel.setFont(new Font("Courier", Font.BOLD, 20));
 
    sendmail = new ImageButton(editor.getImage(editor.getCodeBase(), "images/sendmail_1.gif"));
    closefr = new ImageButton(editor.getImage(editor.getCodeBase(), "images/exit_1.gif"));    
    constrain(but_panel,sendmail, 0,0,1,1, GridBagConstraints.NONE, 
	      GridBagConstraints.CENTER, 0.3, 0.0,0,0,0,0 );
    constrain(but_panel,closefr, 1,0,1,1, GridBagConstraints.NONE, 
	      GridBagConstraints.CENTER, 0.3, 0.0,0,0,0,0 );

    /* Panel containing label for button descriptions...*/
    lblPanel = new Panel();
    lblPanel.setLayout(gridbag);
    butDesc = new TextField(50);
    butDesc.setFont(new Font("Courier", Font.BOLD|Font.ITALIC,14));
    butDesc.setEditable(false);
    butDesc.setBackground(Color.black);
    butDesc.setForeground(Color.white);
    constrain(lblPanel,butDesc, 0,0,1,1, GridBagConstraints.NONE, 
	      GridBagConstraints.CENTER, 0.3, 0.0,0,0,0,0 );
 
   
    /* Panel containing mail headers and message area */
    header_panel = new Panel();
    header_panel.setLayout(gridbag);
    header_panel.setFont(new Font("Courier", Font.BOLD, 20));
    
    cb_group = new CheckboxGroup();
    checkbox = new Checkbox[3];
    checkbox[0] = new Checkbox("",cb_group, false);
    checkbox[1] = new Checkbox("",cb_group, true);
    checkbox[2] = new Checkbox("",cb_group, false);
    
    lblMailTo = new Label("Mail To:");
    lblMailTo.setForeground(lblColor);
    constrain(header_panel, lblMailTo, 0,0,1,1);
    constrain(header_panel, checkbox[0], 1,0,1,1);
    tfMailTo = new TextField( strMailTo, 50 );
    tfMailTo.setFont(new Font("Courier", Font.PLAIN, 14));
    constrain(header_panel, tfMailTo, 5,0,1,1);
    
    lblMailCc = new Label("Mail Cc:");
    lblMailCc.setForeground(lblColor);
    constrain(header_panel, lblMailCc, 0,1,1,1);
    constrain(header_panel, checkbox[1], 1,1,1,1);
    tfMailCc = new TextField( strMailCc, 50 );
    tfMailCc.setFont(new Font("Courier", Font.PLAIN, 14));
    constrain(header_panel, tfMailCc, 5,1,1,1);

    lblMailBcc = new Label("Mail Bcc:");
    lblMailBcc.setForeground(lblColor);
    constrain(header_panel, lblMailBcc, 0,2,1,1);
    constrain(header_panel, checkbox[2], 1,2,1,1);
    tfMailBcc = new TextField( strMailBcc, 50 );
    tfMailBcc.setFont(new Font("Courier", Font.PLAIN, 14));
    constrain(header_panel, tfMailBcc, 5,2,1,1);

    lblMailFcc = new Label("Mail Fcc:");
    lblMailFcc.setForeground(lblColor);
    constrain(header_panel, lblMailFcc, 0,3,1,1);
    tfMailFcc = new TextField( strMailFcc, 50 );
    tfMailFcc.setFont(new Font("Courier", Font.PLAIN, 14));
    constrain(header_panel, tfMailFcc, 5,3,1,1);

    lblAttach = new Label("Attachment:");
    lblAttach.setForeground(lblColor);
    constrain(header_panel, lblAttach, 0,4,1,1);
    tfAttach = new TextField(50);
    tfAttach.setFont(new Font("Courier", Font.PLAIN, 14));
    constrain(header_panel, tfAttach, 5,4,1,1);

    lblSubject = new Label("Subject:");
    lblSubject.setForeground(lblColor);
    constrain(header_panel, lblSubject, 0,5,1,1);
    tfSubject = new TextField( strSubject, 50 );
    tfSubject.setFont(new Font("Courier", Font.PLAIN, 14));
    constrain(header_panel, tfSubject, 5,5,1,1);

    lblMsgBody = new Label("Message Body:");
    lblMsgBody.setForeground(lblColor);
    constrain(header_panel, lblMsgBody, 0,6,1,1);
    ta = new TextArea(15,50);
    ta.setFont(new Font("Courier", Font.PLAIN, 14));
    constrain(header_panel, ta, 5,6,0,0);
    if (frameAction.equals("Forward")) {ta.setText(defaultMsgBody);tfSubject.setText(defaultSubject); butDesc.setText("Frame to Forward mail...");}
    else if (frameAction.equals("Compose")) {butDesc.setText("Frame to Compose and send new mail...");}

    /* Panel containing only one header*/
    panel = new Panel();
    panel.setLayout(gridbag);
    panel.setFont(new Font("Courier", Font.BOLD, 20));
    
    lblAliases = new Label("List of Aliases in Address Book:");
    lblAliases.setForeground(new Color(72, 0, 96));
    constrain(panel, lblAliases, 0,0,1,1);
    
    /* Panel containing list of e-mail alias addresses */
    list_panel = new Panel();
    list_panel.setLayout(gridbag);
    list_panel.setFont(new Font("Courier", Font.BOLD, 20));
    
    aliasList1 = new List(5,true);
    aliasList2 = new List(5,true);
    aliasList3 = new List(5,true);
    
    aliasList1.addItem("furm"); aliasList1.addItem("mohan");
    aliasList1.addItem("sangeeta");aliasList2.addItem("tom");
    aliasList2.addItem("sharad"); aliasList2.addItem("allen");
    aliasList3.addItem("vishal");aliasList3.addItem("gopi");
    aliasList3.addItem("srinivas");
    aliasList1.addItem("furm"); aliasList1.addItem("mohan");
    aliasList1.addItem("sangeeta");aliasList2.addItem("tom");
    aliasList2.addItem("sharad"); aliasList2.addItem("allen");
    aliasList3.addItem("vishal");aliasList3.addItem("gopi");
    aliasList3.addItem("srinivas");
    
    constrain(list_panel, aliasList1, 0,0,1,1,GridBagConstraints.VERTICAL,
	      GridBagConstraints.CENTER, 0.0, 0.0, 0, 0, 0, 0);
    constrain(list_panel, aliasList2, 1,0,1,1,GridBagConstraints.VERTICAL,
	      GridBagConstraints.CENTER, 0.0, 0.0, 0, 0, 0, 0);
    constrain(list_panel, aliasList3, 2,0,1,1,GridBagConstraints.VERTICAL,
	      GridBagConstraints.CENTER, 0.0, 0.0, 0, 0, 0, 0);
    
    this.setLayout(gridbag);
    // And add the panels to the toplevel window
    constrain(this, but_panel, 0, 0, 2, 1, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST, 0.0, 0.0, 10, 0, 0, 0);
    constrain(this, lblPanel, 0, 1, 2, 1, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST, 0.0, 0.0, 10, 0, 0, 0);
    constrain(this, header_panel, 0, 2, 2, 1, GridBagConstraints.BOTH, GridBagConstraints.CENTER, 0.0, 0.0, 10, 0, 10, 0);
    constrain(this, panel, 0, 3, 0, 1, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST, 0.0, 0.0, 5, 10, 10, 10);
    constrain(this,list_panel, 0, 4, 0, 1, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, 0.0, 0.0, 5, 10, 10, 10);
    
    this.pack();
    // this.resize(600,700);
    this.show();
  }

  public boolean handleEvent(Event eve) {
  //public boolean action(Event eve, Object what) {
    
  toSend = "";

  if(eve.id == Event.MOUSE_ENTER) {
    if(eve.target == sendmail) {
      butDesc.setText("Send Mail......");
    }
    else if(eve.target == closefr) {
      butDesc.setText("Close frame......");
    }
  }
  if(eve.id == Event.MOUSE_EXIT) {
    if((eve.target == sendmail) || (eve.target == closefr)) {
      if (frameAction.equals("Compose")) butDesc.setText("Frame to Compose and send new mail....");
      else if (frameAction.equals("Forward")) butDesc.setText("Frame to Forward mail....");
    }
  }
  
  if(eve.id == Event.MOUSE_DOWN) {
    if(eve.target == closefr) {
      this.hide();
      this.dispose();
      return true;
    }
    if(eve.target == sendmail) {
      String to;
      String to_all;
      String cc =  null;
      String cc_all = null;
      String bcc = null;
      String bcc_all = null;
      String fcc =  null;
      String attach =  null;
      String subject =  null;
      String body =  null;
      Vector v = new Vector();
      
      to = tfMailTo.getText();
      cc = tfMailCc.getText();
      bcc = tfMailBcc.getText();
      fcc = tfMailFcc.getText();
      attach = tfAttach.getText();
      subject = tfSubject.getText();
      body = ta.getText();
      
      if(!to.equals("")) {
	v.addElement("To: " + to + "\n");
	to_all = to.replace(',', ' ');
	toSend += to_all + " ";
      }
      if(!cc.equals("")) {
	v.addElement("Cc: " + cc + "\n");
	cc_all = cc.replace(',', ' ');
	toSend += cc_all + " ";
      }
      if(!bcc.equals("")) {
	bcc_all = bcc.replace(',',' ');
	toSend += bcc_all + " ";
      }
      if(!attach.equals("")) v.addElement("Attachment: " + attach + "\n");
      if(!subject.equals("")) v.addElement("Subject: " + subject + "\n");
      v.addElement("\n");
      if(!body.equals("")) v.addElement(body);
      
      array = new String[v.size()];
      v.copyInto(array);
      String s = "";
      for(int i =0; i < array.length; i++) 
	s +=array[i];
      out.println("SENDMAIL {" + s.length() + "} " + toSend);
      out.println(s);
      tfMailTo.setText(""); tfMailCc.setText(""); tfMailBcc.setText("");
      tfMailFcc.setText(""); tfAttach.setText(""); tfSubject.setText(""); ta.setText("");
      return true;
    }
  }
  return false;
  //return true;
  }

  public void constrain(Container container, Component component,
			int grid_x, int grid_y, int grid_width, int grid_height,
			int fill, int anchor, double weight_x, double weight_y,
			int top, int left, int bottom, int right)
    {
      GridBagConstraints c = new GridBagConstraints();
      c.gridx = grid_x; c.gridy = grid_y;
      c.gridwidth = grid_width; c.gridheight = grid_height;
      c.fill = fill; c.anchor = anchor;
      c.weightx = weight_x; c.weighty = weight_y;
      if (top+bottom+left+right > 0)
	c.insets = new Insets(top, left, bottom, right);
      
      ((GridBagLayout)container.getLayout()).setConstraints(component, c);
      container.add(component);
    }
  
  public void constrain(Container container, Component component,
			int grid_x, int grid_y, int grid_width, int grid_height) {
    constrain(container, component, grid_x, grid_y,
	      grid_width, grid_height, GridBagConstraints.NONE,
	      GridBagConstraints.NORTHWEST, 0.0, 0.0, 0, 0, 0, 0);
  }
  
  public void constrain(Container container, Component component,
			int grid_x, int grid_y, int grid_width, int grid_height,
			int top, int left, int bottom, int right) {
    constrain(container, component, grid_x, grid_y,
	      grid_width, grid_height, GridBagConstraints.NONE,
	      GridBagConstraints.NORTHWEST,
	      0.0, 0.0, top, left, bottom, right);
  }
  public String[] getArray () { return array; }
  public String getToSend () { return toSend; }
}
