package webmail.frames;

import java.net.*;
import java.io.*;
import java.util.*;
import webmail.imap.*;
//import webmail.frames.*;

public class Server extends Thread {

public final static int DEFAULT_PORT = 2345;
protected int port;
protected static ServerSocket listen_socket;
private static String name_of_folder;
private static IndexFormat indexformat;
private static IMAPClient imapc;
private static MailFormat mailf;
boolean condition = true;
private static boolean server_start = true;

public static void fail(Exception e, String msg)  {
  System.err.println(msg + ":" + e );
  System.exit(1);
}
     
  public Server(int port, String foldername, IndexFormat indfor, IMAPClient imapC) {
  
  name_of_folder = foldername;
  indexformat = indfor;
  imapc = imapC;
  System.out.println("in server");
  if(server_start) {
    
    if (port==0)
      port=DEFAULT_PORT;
    this.port = port;
    try { 
      listen_socket = new ServerSocket(port);
    }
    catch (IOException e) {fail(e,"Exception creating server socket");}
    System.out.println("Server listening on port " + port);
    this.start();
    server_start = false;
  }
}

public void run() {
  try {
    while(condition) {
	Socket client_socket = listen_socket.accept();
	Connection c = new Connection(client_socket, name_of_folder, indexformat, imapc);
    }
  }	
  catch(IOException e) {fail(e,"Exception while listening for connections");}
}	
}

class Connection extends Thread {
  protected Socket client;
  protected DataInputStream in;
  protected PrintStream out;
  private static String FolderName;
  private static IndexFormat indexf;
  private static IMAPClient imapc;
  private static MailFormat mailf;

  public Connection(Socket client_socket, String name, IndexFormat ind, IMAPClient imapC ) {
    client = client_socket;
    FolderName = name;
    imapc = imapC;
    indexf = ind;

    try {
      in = new DataInputStream(client.getInputStream());
      out = new PrintStream(client.getOutputStream());
    }
    catch(IOException e) {
      try {client.close();}
      catch(IOException e2){
	System.err.println("Exception while getting socket streams:"+e);}
      return;
    }
    System.out.println("Information Received from: " + client.getInetAddress());
    this.start();
  }

  private void process_index() {   
    int total_mails = indexf.getNumTotal();
    int count = 1;
    String msg_state = "";
    out.println(total_mails);
    for(int i = 0; i < total_mails ; i++) {
      if(!indexf.getIsSeen(i)) msg_state = "N";
      else if(indexf.getIsAnswered(i)) msg_state = "A";
      else if(indexf.getIsDeleted(i)) msg_state = "D";
      else msg_state = "R";
      
      String msg_size = "(" + indexf.getMessageSize(i) + ")";
      String msg_subject = indexf.getSubject(i);
      
      AddressFormat af = indexf.getFrom(i);
      String from = af.getPersonalName();
      String date = indexf.getDate(i);
      StringTokenizer st = new StringTokenizer(date);
      String day =  (st.nextToken());
      String date1 = (st.nextToken());
      String month =  (st.nextToken());
      String msg_date = month + " " + date1;

      if((msg_date.length()) == 5) msg_date = msg_date + " ";
      if(count<10) msg_date = " " + msg_date;
      int name_diff = 28 - (from.length());
      for (int p = 0; p < name_diff; p++) from = from + " ";
      int size_diff = 7 - (msg_size.length());
      for (int q = 0; q < size_diff; q++) msg_size = msg_size + " ";
      
      out.println(msg_state + "  " + count + " " + msg_date + " " + from + "   " + msg_size + "  " + msg_subject);
      count = count + 1;
    }
  }

  public void run() {
    String inline;

    process_index();

    try {
      for(;;) {
	inline = in.readLine();
	System.out.println("read no." + inline);
	if(inline.startsWith("SENDMAIL ")) {
	  int bodyLength = Integer.parseInt(inline.substring("SENDMAIL {".length(),inline.indexOf('}')));
	  System.out.println(inline.substring("SENDMAIL {".length(),inline.indexOf('}'))+" "+bodyLength);
	  String toSend = inline.substring(inline.indexOf('}')+2);
	  String s = "";
	  for( ; s.length() < bodyLength ;) 
	    s += in.readLine() + "\n";
	  
	  SendMail sm = new SendMail (toSend, s);
	  sm.sendMessage();
	}
	else if(inline.startsWith("DELETE ")) {
	  int mail_number = Integer.parseInt(inline.substring("DELETE ".length()));
	  imapc.delete(mail_number,true);
	}
	else if(inline.startsWith("UNDELETE ")) {
	  int mail_number = Integer.parseInt(inline.substring("UNDELETE ".length()));
	  imapc.delete(mail_number,false);
	}
	else if(inline.startsWith("EXPUNGE")) {
	  imapc.expunge(); 
	  imapc.selectMailbox("INBOX");
	  indexf = imapc.index();
	  out.println("EXPUNGE");
	  System.out.println("EXPUNGE");
	  process_index();
	}
	else if (inline.startsWith("MAILNO ")) {
	  int mail_no = Integer.parseInt(inline.substring("MAILNO ".length()));
	  String date = indexf.getDate(mail_no-1);
	  String sub = indexf.getSubject(mail_no-1);
	  
	  mailf = imapc.body(mail_no);
	  String from = mailf.getFrom().value();
	  String personalName = mailf.getFrom().getMailboxName();
	  String hostName = mailf.getFrom().getHostName();
	  System.out.println("name = " + personalName+" hostname = "+hostName);
	  String replyTo = mailf.getReplyTo().value();
	  AddressFormat[] toAF = mailf.getTo();
	  AddressFormat[] ccAF = mailf.getCc();
	  AddressFormat[] bccAF = mailf.getBcc();
	  
	  String to = "";
	  for (int i=0; i<toAF.length-1; i++)
	    to += toAF[i].value() + ", ";
	  if (toAF.length != 0)
	    to += toAF[toAF.length-1].value();
	  
	  String cc = "";
	  for (int i=0; i<ccAF.length-1; i++)
	    cc += ccAF[i].value() + ", ";
	  if (ccAF.length != 0)
	    cc += ccAF[ccAF.length-1].value();
	  
	  String bcc = "";
	  for (int i=0; i<bccAF.length-1; i++)
	    bcc += bccAF[i].value() + ", ";
	  if (bccAF.length != 0)
	    bcc += bccAF[bccAF.length-1].value();
	  
	  String header = "Date: " + date + "\n" + "From: " + from + "\n" + "Pname: " + personalName + "\n" + "Hname: " + hostName + "\n";
	  if(!to.equals(""))
	    header += "To: " + to + "\n";
	  if(!cc.equals(""))
	    header += "Cc: " + cc + "\n";
	  if(!sub.equals(""))
	    header += "Subject: " + sub + "\n";
	  StringBuffer sbuf = new StringBuffer();
	  String [] msg = mailf.getMessageBody();
	  for(int i = 0; i < msg.length; i++) 
	    sbuf.append(msg[i]+"\n");
	  String body = sbuf.toString();
	  out.println ( header + "{" + body.length() + "}\n\n" + body );
	}
      }
    }
    catch (IOException e) {;}
  }   // end of run() function
}


