//package webmail.frames;

import java.awt.*;
import java.applet.*;
import java.net.*;
import java.io.*;
import java.util.*;
import gjt.ImageButton;
import gjt.ImageButtonEvent;
//import webmail.frames.*;

//////////////////////////////////////////////////////////////////////////////
//  class Editor: <description>
//////////////////////////////////////////////////////////////////////////////
public class Editor extends Applet{
  public static final int PORT = 5555;
  private Socket sock;
  private DataInputStream in;
  private PrintStream out;
  EditorConnection conn;
  ListPanel lp;
  ControlPanel cp;
  private MailPanel mp;
  //static private boolean first_entry = true;
  private int mail_index_num = 0;

  // Called to initialize the applet.
  public void init ( ) {

    System.gc();
    setLayout(new BorderLayout());
    setBackground(new Color(255, 208, 160));
    lp = new ListPanel(this);
    mp = new MailPanel(this);

      try {
	System.out.println ("Editor in try loop");
	sock = new Socket(this.getCodeBase().getHost(),PORT);
	System.out.println("Editor socket name :" + sock.toString());
	in = new DataInputStream(sock.getInputStream());
	out = new PrintStream ( sock.getOutputStream() );
	conn = new EditorConnection(this, in, out, lp.mailIndex, mp.mailContent, mp.headerContent, mp.photoPanel, mp.logoPanel);
      }
      catch (IOException e) { System.out.println("Editor ex: "+e.toString()); }
      finally  { ; }

      cp = new ControlPanel(this, out, conn);

      add("North", cp);
      add("Center", lp);
      add("South", mp);
   }

  // Called when the user clicks the list
  public boolean action(Event event, Object arg) {
    if(event.target == lp.mailIndex) {
      StringBuffer strbuff = new StringBuffer();
      String str = "";
      strbuff.append(str + "\n");
      mp.mailContent.setText(strbuff.toString());

      StringBuffer msgbuff = new StringBuffer(conn.getMsgText());
      mp.mailContent.setText(new String(msgbuff));

      mail_index_num = lp.mailIndex.getSelectedIndex() + 1;
      String item = lp.mailIndex.getSelectedItem();
      if(item.charAt(0) == 'N') {
	item = "R" + item.substring(1);
      }
      lp.mailIndex.replaceItem(item,mail_index_num-1);
      System.out.println("list selected:" + mail_index_num);
      return true;
    }
    return false;
  }
  public boolean handleEvent(Event event) {
    if(event.id == Event.LIST_SELECT) {
      int mail_index = lp.mailIndex.getSelectedIndex();
      int mail_index_sent = mail_index + 1;
      StringBuffer stbuff = new StringBuffer();
      String str = "";
      stbuff.append(str);
      mp.headerContent.setText(stbuff.toString());
      out.println("MAILNO " +mail_index_sent);
      System.out.println("list selected mail:" + mail_index);
      if(cp.cbox1.getState() == true) {
	String name = lp.mailIndex.getSelectedItem();
	name = "D" + name.substring(1);
	lp.mailIndex.replaceItem(name,mail_index);
	out.println("DELETE "+ (mail_index+1));
      }
      if(cp.cbox2.getState() == true) {
	String name = lp.mailIndex.getSelectedItem();
	name = "R" + name.substring(1);
	lp.mailIndex.replaceItem(name,mail_index);
	out.println("UNDELETE "+ (mail_index+1));
      }
      if(cp.cbox3.getState() == true) {
	out.println("EXPUNGE");
	StringBuffer sbuff = new StringBuffer();
	String s = "";
	sbuff.append(s + "\n");
	mp.mailContent.setText(sbuff.toString());
	mp.headerContent.setText(sbuff.toString());
	cp.cbox3.setState(false);
	cp.cbox4.setState(true);
      }
      return true;
    }
    return super.handleEvent(event);
  }
}

//////////////////////////////////////////////////////////////////////////////
//  class ControlPanel: <description>
//////////////////////////////////////////////////////////////////////////////
class ControlPanel extends Panel {
  private Editor ed;
  private Button b1, b2, b3, b4;
  private ImageButton cmp_but, fwd_but, reply_but, save_but;
  Checkbox cbox1, cbox2, cbox3, cbox4;
  private ComposeFrame cmpframe;
  private ReplyFrame replyframe;
  private saveFrame saveframe;
  private Panel main1, main2, p1, p2, p3;
  private Label label;
  private PrintStream outprn;
  EditorConnection conn;
  private Font cboxFont;
  private Color cboxColor;

  public ControlPanel(Editor editor, PrintStream outs, EditorConnection c) {
    ed = editor;
    outprn = outs;
    conn = c;
    setLayout(new BorderLayout());       
    CheckboxGroup cg = new CheckboxGroup();
    
    p1 = new Panel();
    p2 = new Panel();
    cboxFont = new Font("Courier", Font.BOLD, 22);
    cboxColor = new Color(24, 96, 0);
    
    p1.setLayout(new FlowLayout());    
    /*p1.setFont(new Font("Helvitica", Font.BOLD, 22));
    p1.add(b1 = new Button("Compose"));
    p1.add(b2 = new Button("Forward"));
    p1.add(b3 = new Button("Reply"));
    p1.add(b4 = new Button("Save"));*/
    cmp_but = new ImageButton(ed.getImage(ed.getCodeBase(), "images/cmpmail_1.gif"));
    fwd_but = new ImageButton(ed.getImage(ed.getCodeBase(), "images/mail_lots1.gif"));
    reply_but = new ImageButton(ed.getImage(ed.getCodeBase(), "images/mb3_1.gif"));
    save_but = new ImageButton(ed.getImage(ed.getCodeBase(), "images/eyemail_1.gif"));
    p1.add(cmp_but);
    p1.add(fwd_but);
    p1.add(reply_but);
    p1.add(save_but);

    p2.setLayout(new FlowLayout());
    cbox1 = new Checkbox("Delete Mail",cg, false);
    cbox1.setFont(cboxFont);
    cbox1.setForeground(cboxColor);
    cbox2 = new Checkbox("Undelete Mail",cg, false);
    cbox2.setFont(cboxFont);
    cbox2.setForeground(cboxColor);
    cbox3 = new Checkbox("Expunge Mails",cg, false);
    cbox3.setFont(cboxFont);
    cbox3.setForeground(cboxColor);
    cbox4 = new Checkbox("None",cg, true);
    cbox4.setFont(cboxFont);
    cbox4.setForeground(cboxColor);
    p2.add(cbox1);
    p2.add(cbox2);
    p2.add(cbox3);
    p2.add(cbox4);

    add("North", p1);
    add("South",p2);
  }

  public boolean handleEvent(Event e) {
  if(e.id == Event.MOUSE_DOWN) {
  //public boolean action(Event e, Object arg) {
  //if(e.target instanceof ImageButton) {
  //if(e.arg.equals("Compose")) {
	if(e.target == cmp_but) {
	try {
	  System.out.println ("Composing mail..  wait");
	  cmpframe = new ComposeFrame("Compose", outprn);
	  cmpframe.show();
	}
	catch (Exception ex) {return false;}
	return true;
      }
      else if(e.target == fwd_but) {
	//else if(e.arg.equals("Forward")) {
	try {
	  System.out.println ("Forwarding mail..  wait");
	  String msg = "\n\n---------- Forwarded message ----------\n"+conn.getMsgHeader()+"\n"+conn.getMsgText();
	  String sub = conn.getSubject() + " (fwd)";
	  cmpframe = new ComposeFrame("Forward", outprn, msg, sub);
	}
	catch (Exception ex) {return false;}
	return true;
      }
	//else if(e.arg.equals("Reply")) {
      else if(e.target == reply_but) {
	try {
	  System.out.println ("Replying to mail..  wait");
	  StringBuffer sbuff = new StringBuffer ( conn.getMsgText() );
	  replyframe = new ReplyFrame("Reply", outprn, conn.getFrom(),
				      conn.getTo() + ", " + conn.getCc(), 
				      "", "", 
				      "Re: "+conn.getSubject(), new String(sbuff));
	}
	catch (Exception ex) {return false;}
	return true;
      }
	//else if(e.arg.equals("Save")) {
      else if(e.target == save_but) {
	try {
	  System.out.println ("Saving mail..  wait");
	  saveframe = new saveFrame("Save");
	}
	catch (Exception ex) {return false;}
	return true;
      }
    }
    return true;
  }
}

//////////////////////////////////////////////////////////////////////////////
//  class ListPanel: <description>
//////////////////////////////////////////////////////////////////////////////
class ListPanel extends Panel {
  static List mailIndex;
  private Editor ed;
  private Panel p1, p2, p3;
  private Label header1, header2;
  private Font msgFont;
  private Color msgColor;
  
  public ListPanel(Editor editor) {
    ed = editor;
    setLayout(new BorderLayout());
    p1 = new Panel();
    p2 = new Panel();
    p3 = new Panel();
    msgFont = new Font("Courier", Font.BOLD, 22);
    msgColor = new Color(160,0,0);

    p1.setFont(msgFont);
    header1= new Label("List of messages in current folder");
    header1.setForeground(msgColor);
    p1.add(header1);
    mailIndex = new List();
    mailIndex.setMultipleSelections(false);
    mailIndex.setFont(new Font("Courier", Font.PLAIN,12));
    mailIndex.resize(650, 400);
    mailIndex.setBackground(new Color(224,255,224));
    p2.setLayout(new BorderLayout());
    p2.resize(750,400);
    p2.add("Center",mailIndex);
    p3.setFont(msgFont);
    header2 = new Label("Mail Message");
    header2.setForeground(msgColor);
    p3.add(header2);
    add("North", p1);
    add("Center", p2);
    add("South", p3);
  }
}

//////////////////////////////////////////////////////////////////////////////
//  class MailPanel: <description>
//////////////////////////////////////////////////////////////////////////////
class MailPanel extends Panel {
  TextArea mailContent, headerContent;
  private Editor ed;
  CardLayout cl;
  Panel topPanel, msgPanel, containPanel, headerPanel; 
  PhotoPanel photoPanel;
  LogoPanel logoPanel;
  EvalPanel evalPanel;
  Label logoLbl, evalLbl, photoLbl;
  EditorConnection edconn;
  GridBagLayout gridbag = new GridBagLayout();

  public Image getLogoImage() {
    return ed.getImage(ed.getCodeBase(), "logos/webmail1.gif");
  }

  public Image getPhotoImage() {
    return ed.getImage(ed.getCodeBase(), "people/welcome1.gif");
  }

  public Image getEvalImage() {
    return ed.getImage(ed.getCodeBase(), "images/smiling_1.gif");
  }

  public MailPanel(Editor editor) {
    ed = editor;
    setLayout(new GridLayout(2,1));
    topPanel = new Panel();
    msgPanel = new Panel();
    headerPanel = new Panel();
    containPanel = new Panel();

    String dummyLbl = "    ";
    photoPanel = new PhotoPanel(getPhotoImage(), dummyLbl, 40, 15);
    logoPanel = new LogoPanel(getLogoImage(), dummyLbl, 50, 0);
    evalPanel = new EvalPanel(getEvalImage(), dummyLbl, 290, 0);

    containPanel.setLayout(new GridLayout(1,3));
    //containPanel.setLayout(new FlowLayout());
    //containPanel.setLayout(gridbag);
    topPanel.setLayout(new GridLayout(2,1));
    
    headerPanel.setLayout(new BorderLayout());
    headerContent = new TextArea ("",5,45);
    headerContent.setEditable(false);
    headerContent.setBackground(new Color(224,255,224));
    headerPanel.add("Center", headerContent);

    containPanel.add(photoPanel);
    containPanel.add(headerPanel);
    containPanel.add(logoPanel);

    /*    constrain(containPanel, photoPanel, 0,0,1,1, GridBagConstraints.NONE,GridBagConstraints.CENTER, 0.3, 0.0,0,0,0,0);
    constrain(containPanel, headerPanel, 1,0,1,1, GridBagConstraints.NONE,GridBagConstraints.CENTER, 0.3, 0.0,0,0,0,0);
    constrain(containPanel, logoPanel, 2,0,1,1, GridBagConstraints.NONE,GridBagConstraints.CENTER, 0.3, 0.0,0,0,0,0);*/

    msgPanel.setLayout(new FlowLayout());
    mailContent = new TextArea ("",15,60);
    mailContent.setEditable(false);
    mailContent.setBackground(new Color(224,255,224));
    msgPanel.add(mailContent);

    topPanel.add(containPanel);
    topPanel.add(evalPanel);
    add(topPanel);
    add(msgPanel);
  }

  public void constrain(Container container, Component component,
            int grid_x, int grid_y, int grid_width, int grid_height,
            int fill, int anchor, double weight_x, double weight_y,
            int top, int left, int bottom, int right)
    {
      GridBagConstraints c = new GridBagConstraints();
      c.gridx = grid_x; c.gridy = grid_y;
      c.gridwidth = grid_width; c.gridheight = grid_height;
      c.fill = fill; c.anchor = anchor;
      c.weightx = weight_x; c.weighty = weight_y;
      if (top+bottom+left+right > 0)
	c.insets = new Insets(top, left, bottom, right);

      ((GridBagLayout)container.getLayout()).setConstraints(component, c);
      container.add(component);
    }
  
public void constrain(Container container, Component component,
		      int grid_x, int grid_y, int grid_width, int grid_height) {
  constrain(container, component, grid_x, grid_y,
	    grid_width, grid_height, GridBagConstraints.NONE,
	    GridBagConstraints.NORTHWEST, 0.0, 0.0, 0, 0, 0, 0);
}
  
public void constrain(Container container, Component component,
		      int grid_x, int grid_y, int grid_width, int grid_height,
		      int top, int left, int bottom, int right) {
  constrain(container, component, grid_x, grid_y,
	      grid_width, grid_height, GridBagConstraints.NONE,
	      GridBagConstraints.NORTHWEST,
	      0.0, 0.0, top, left, bottom, right);
}
  
}

////////////////////////////////////////////////////////////////////////////
//   
//     class PhotoPanel
////////////////////////////////////////////////////////////////////////////
class PhotoPanel extends Panel {
  private Image img;
  PhotoCanvas photoimg;
  private String labelTxt;
  private int xpos, ypos;
  private Label photoLbl;

public PhotoPanel() {}

public PhotoPanel(Image i, String txt, int x, int y) {
  img = i;
  labelTxt = txt;
  xpos = x;
  ypos = y;
  setLayout(new BorderLayout());
  photoimg = new PhotoCanvas(img, xpos, ypos);
  add("Center",photoimg);
  photoLbl = new Label(labelTxt, Label.CENTER);
  photoLbl.setForeground(new Color(24, 96, 0));
  photoLbl.setFont(new Font("Courier", Font.BOLD|Font.ITALIC, 20));
  add("South", photoLbl);
}

public void setLabelTxt(String txt) {
  photoLbl.setText(txt);
}


public void imageDraw(Image i, int x, int y){
  img = i;
  xpos = x;
  ypos = y;
  photoimg.redrawPhoto(img, xpos, ypos);
}
}

////////////////////////////////////////////////////////////////////////////
//   
//     class PhotoCanvas
////////////////////////////////////////////////////////////////////////////
class PhotoCanvas extends Canvas {
  private Image image;
  private int xpos, ypos;

public PhotoCanvas(Image MyImage, int x, int y) {
  image = MyImage;
  xpos = x;
  ypos = y;
}

public void update(Graphics g) {
  g.drawImage(image, xpos, ypos, this); 
}

public void paint(Graphics g) {
  update(g); 
}

public void redrawPhoto(Image i, int x, int y) { 
  image = i;
  xpos = x;
  ypos = y;
  update(getGraphics());
}
}

////////////////////////////////////////////////////////////////////////////
//   
//     class LogoPanel
////////////////////////////////////////////////////////////////////////////
class LogoPanel extends Panel {
  private Image img;
  LogoCanvas logoimg;
  private String labelTxt;
  private int xpos, ypos;
  Label logoLbl;

public LogoPanel() {}

public LogoPanel(Image i, String txt, int x, int y) {
  img = i;
  labelTxt = txt;
  xpos = x;
  ypos = y;
  setLayout(new BorderLayout());
  logoimg = new LogoCanvas(img, xpos, ypos);
  add("Center",logoimg);
  logoLbl = new Label(labelTxt, Label.CENTER);
  logoLbl.setForeground(new Color(24, 96, 0));
  logoLbl.setFont(new Font("Courier", Font.BOLD|Font.ITALIC, 20));
  add("South", logoLbl);
}

public void setLabelTxt(String txt) {
  logoLbl.setText(txt);
}

public void logoDraw(Image i, int x, int y){
  img = i;
  xpos = x;
  ypos = y;
  logoimg.redrawLogo(img, xpos, ypos);
}
}

////////////////////////////////////////////////////////////////////////////
//   
//     class LogoCanvas
////////////////////////////////////////////////////////////////////////////
class LogoCanvas extends Canvas {
  private Image image;
  private int xpos, ypos;

public LogoCanvas(Image MyImage, int x, int y) {
  image = MyImage;
  xpos = x;
  ypos = y;
}

public void update(Graphics g) {
  g.drawImage(image, xpos, ypos, this);
}

public void paint(Graphics g) {
  update(g);
}

public void redrawLogo(Image i, int x, int y) { 
  image = i;
  xpos = x;
  ypos = y;
  update(getGraphics());
}
}

////////////////////////////////////////////////////////////////////////////
//   
//     class EvalPanel
////////////////////////////////////////////////////////////////////////////
class EvalPanel extends Panel {
  private Image img;
  EvalCanvas evalimg;
  Label evalLbl;
  private String labelTxt;
  private int xpos, ypos;

public EvalPanel() {}

public EvalPanel(Image i, String txt, int x, int y) {
  img = i;
  labelTxt = txt;
  xpos = x;
  ypos = y;
  setLayout(new BorderLayout());
  evalimg = new EvalCanvas(img);
  add("Center",evalimg);
  evalLbl = new Label(labelTxt, Label.CENTER);
  evalLbl.setForeground(new Color(24, 96, 0));
  evalLbl.setFont(new Font("Courier", Font.BOLD|Font.ITALIC, 20));
  add("South", evalLbl);
}

public void setLabelTxt(String txt) {
  evalLbl.setText(txt);
}

public void evalDraw(Image i){
  img = i;
  evalimg.redrawEval(img);
}
}

////////////////////////////////////////////////////////////////////////////
//   
//     class EvalCanvas
////////////////////////////////////////////////////////////////////////////
class EvalCanvas extends Canvas {
  private Image image;

public EvalCanvas(Image MyImage) {
  image = MyImage;
}

public void update(Graphics g) {
  g.drawImage(image, 290, 0, this);
}

public void paint(Graphics g) {
  update(g);
}

public void redrawEval(Image i) { 
  image = i;
  update(getGraphics());
}
}

//////////////////////////////////////////////////////////////////////////////
//  class EditorConnection: <description>
//////////////////////////////////////////////////////////////////////////////
class EditorConnection extends Thread {
  List mailInd;
  TextArea txtarea, headarea;
  DataInputStream in;
  PrintStream out;
  private Editor edit;
  StringBuffer sbuf = new StringBuffer();
  private String msgText = "";
  private String msgHeader = "";
  private String date="", from="", to="", cc="", subject="";
  private String personalName="", hostName="";
  static final int NONE=0, HEADER=1, BODY=2;
  private String[] name_array = {"shrideep", "afoxman", "gkhoury", "gult", "kipp", "prakash", "psycho"};
  private String[] logo_array = {"npac", "mcgill", "hscsyr", "jhu"};
  PhotoPanel imagePanel;
  LogoPanel logPanel;
  boolean imageFound = false;
  boolean logoFound = false;

public EditorConnection(Editor ed, DataInputStream in, 
			PrintStream out, List l, TextArea ta, 
			TextArea headta, PhotoPanel imgPanel, 
			LogoPanel lgPanel) {
    edit = ed;
    mailInd = new List();
    mailInd.setFont(new Font("Courier", Font.PLAIN,12));
    mailInd.setMultipleSelections(false);
    mailInd.setBackground(new Color(224,255,224));
    mailInd.resize(650,400);
    mailInd = l;
    txtarea = new TextArea("",15,60);
    txtarea.setBackground(new Color(224,255,224));
    txtarea = ta;
    headarea = new TextArea("",5,45);
    headarea.setBackground(new Color(224,255,224));
    headarea = headta;
    imagePanel = imgPanel;
    logPanel = lgPanel; 
    this.in = in;
    this.out = out;
    this.start();
  }

  public String getMsgText() {return msgText;}
  public String getMsgHeader() {return msgHeader;}
  public String getDate() {return date;}
  public String getFrom() {return from;}
  public String getTo() {return to;}
  public String getCc() {return cc;}
  public String getSubject() {return subject;}

  public void run() {
    String readline;
    int state=NONE;

    list_index();
    
    for (;;) {
      try {
	readline = in.readLine();
	if((state==NONE) && readline.startsWith("Date:")) {
	  msgHeader = "";
	  date = readline.substring("Date: ".length());
	  headarea.appendText(readline+"\n");
	  msgHeader += "> "+readline + "\n";
	  state=HEADER;
	}
	else if((state==HEADER) && readline.startsWith("From:")) {
	  from = readline.substring("From: ".length());
	  headarea.appendText(readline+"\n");
	  msgHeader += "> "+readline + "\n";
	}
	else if((state==HEADER) && readline.startsWith("Pname:")) {
	  personalName = readline.substring("Pname: ".length());
	  imageFound = false;
	  for(int p =0; p < name_array.length; p++) {
	    if (name_array[p].equals(personalName)) {
	      System.out.println("name matched to: " + personalName);
	      imagePanel.imageDraw(edit.getImage(edit.getCodeBase(), "people/plain.gif"), 40, 0);
	      imagePanel.setLabelTxt("Sender: "+personalName);
	      imageFound = true;
	      imagePanel.imageDraw(edit.getImage(edit.getCodeBase(), "people/"+personalName+".gif"), 65, 0);
	    }
	  }
	  if(!imageFound) {
	      imagePanel.imageDraw(edit.getImage(edit.getCodeBase(), "people/plain.gif"), 40, 0);
	    imagePanel.imageDraw(edit.getImage(edit.getCodeBase(), "people/no_img.gif"), 40, 0);
	    imagePanel.setLabelTxt("Sender");
	    imageFound = false;
	  }
	}
	else if((state==HEADER) && readline.startsWith("Hname:")) {
	  hostName = readline.substring("Hname: ".length());
	  logoFound = false;
	  StringTokenizer st = new StringTokenizer(hostName,".");
	  while(st.hasMoreTokens()) {
	    String str = st.nextToken();
	    for(int q = 0; q < logo_array.length; q++) {
	      if (logo_array[q].equals(str)) {
		System.out.println("host is " + str);
		logPanel.logoDraw(edit.getImage(edit.getCodeBase(), "logos/plain.gif"), 50, 0);
		logPanel.setLabelTxt("Logo: "+str);
		logoFound = true;
		logPanel.logoDraw(edit.getImage(edit.getCodeBase(), "logos/"+str+".gif"), 80, 0);
	      }
	    }
	  }
	  if(!logoFound) {
	    logPanel.logoDraw(edit.getImage(edit.getCodeBase(), "logos/plain.gif"), 50, 0);
	    logPanel.logoDraw(edit.getImage(edit.getCodeBase(), "logos/no_img.gif"), 80, 0);
	    logPanel.setLabelTxt("Logo");
	    logoFound = false;
	  }
	}
	else if((state==HEADER) && readline.startsWith("To:")) {
	  to = readline.substring("To: ".length());
	  headarea.appendText(readline+"\n");
	  msgHeader += "> "+readline + "\n";
	}
	else if((state==HEADER) && readline.startsWith("Cc:")) {
	  cc = readline.substring("Cc: ".length());
	  headarea.appendText(readline+"\n");
	  msgHeader += "> "+readline + "\n";
	}
	else if((state==HEADER) && readline.startsWith("Subject:")) {
	  subject = readline.substring("Subject: ".length());
	  headarea.appendText(readline+"\n");
	  msgHeader += "> "+readline + "\n";
	}
	else if (state == HEADER) {
	  int len = Integer.parseInt(readline.substring(1,readline.length()-1));
	  msgText = "";
	  int lenSoFar = 0;
	  for ( ; lenSoFar < len; ) {
	    readline=in.readLine();
	    msgText += "> "+readline + "\n";
	    lenSoFar += readline.length() + 1;
	  }
	  state = NONE;
	}
	else if((state==NONE) && readline.equals("EXPUNGE")) {
	  System.out.println("before calling list index " + readline);
	  list_index();
	  System.out.println("after calling list index " );
	}
      } catch (IOException e) {;}
    }
  }

  private void list_index() {
    try {
      mailInd.clear();
      int no_mails = (Integer.valueOf(in.readLine())).intValue();
      for(int i=0; i < no_mails; i++) {
	String readline = in.readLine();
	mailInd.addItem(readline);
      }
    }catch (IOException ioe) {;}
  }
}

