//package webmail.version2;

import java.awt.*;
import java.io.*;
import gjt.ImageButton;
import gjt.ImageButtonEvent;

class SaveFrame extends Frame {
  private ImageButton savemail, okfr;
  private Label lbl1, lbl2;
  private TextField tf1, tf2, butDesc, fldrResponse;
  private Panel butPanel, folderPanel, lblPanel, queryPanel;
  private Button yes_but, no_but;
  private Font buttonFont;
  private Color buttonColor;
  static String FolderName = "";
  private Editor editor;
  private PrintStream out;
  static boolean newFolderCreated = false;

  GridBagLayout gridbag = new GridBagLayout();

public SaveFrame(Editor ed, String type, PrintStream outps ) {
  super(type + " Mail");
  editor = ed;
  out = outps;

  setBackground(new Color(255, 228, 225));

  /* Panel containing buttons...*/
  butPanel = new Panel();
  butPanel.setLayout(new FlowLayout());
  butPanel.setLayout(gridbag);
  butPanel.setFont(new Font("Helvitica", Font.BOLD, 18));

  savemail = new ImageButton(editor.getImage(editor.getCodeBase(), "images/savemail_1.gif"));
  okfr = new ImageButton(editor.getImage(editor.getCodeBase(), "images/exit_1.gif"));    
  constrains(butPanel,savemail, 0,0,1,1, GridBagConstraints.NONE, 
	   GridBagConstraints.CENTER, 0.3, 0.0,0,0,0,0 );
  constrains(butPanel, okfr, 1,0,1,1, GridBagConstraints.NONE, 
	   GridBagConstraints.CENTER, 0.3, 0.0,0,0,0,0 );

  
  /* Panel containing label for button descriptions...*/
  lblPanel = new Panel();
  lblPanel.setLayout(gridbag);
  butDesc = new TextField(50);
  butDesc.setEditable(false);
  butDesc.setFont(new Font("Courier", Font.BOLD|Font.ITALIC,14));
  butDesc.setText("Frame to save mail to a specific folder...");
  butDesc.setBackground(Color.black);
  butDesc.setForeground(Color.white);
  constrains(lblPanel,butDesc, 0,0,1,1, GridBagConstraints.NONE, 
	    GridBagConstraints.CENTER, 0.3, 0.0,0,0,0,0 );
  
  /* Panel containing textfield for entry of foldername...*/
  folderPanel = new Panel();
  folderPanel.setLayout(gridbag);
  folderPanel.setFont(new Font("Courier", Font.BOLD, 20));

  lbl1 = new Label("Save Mail to Folder:");
  lbl1.setForeground(new Color(24, 96, 0));
  constrains(folderPanel, lbl1, 0,0,1,1);
  tf1 = new TextField(40);
  tf1.setFont(new Font("Courier", Font.BOLD, 14));
  constrains(folderPanel, tf1, 1,0,1,1);

  buttonFont = new Font("Courier", Font.BOLD, 22);
  buttonColor = new Color(72, 0, 96);
  queryPanel = new Panel();
  queryPanel.setLayout(gridbag);
  CheckboxGroup cg = new CheckboxGroup();
  fldrResponse  = new TextField(50);
  fldrResponse.setFont(new Font("Helvitica", Font.BOLD, 14));
  fldrResponse.setForeground(new Color(24, 96, 0));
  fldrResponse.setEditable(false);
  yes_but = new Button(" Yes ");
  yes_but.setFont(buttonFont);
  yes_but.setForeground(buttonColor);
  yes_but.setBackground(Color.lightGray);
  no_but = new Button(" No ");
  no_but.setFont(buttonFont);
  no_but.setBackground(Color.lightGray);
  no_but.setForeground(buttonColor);

  fldrResponse.show(false);
  yes_but.show(false);
  no_but.show(false);
  this.pack();

  constrains(queryPanel,fldrResponse, 0,0,1,1, GridBagConstraints.NONE, GridBagConstraints.CENTER, 0.3, 0.0,0,0,0,0 );
  constrains(queryPanel, yes_but , 1,0,1,1, GridBagConstraints.NONE,GridBagConstraints.CENTER, 0.3, 0.0,0,0,0,0 );
  constrains(queryPanel, no_but , 2,0,1,1, GridBagConstraints.NONE,GridBagConstraints.CENTER, 0.3, 0.0,0,0,0,0 );
  
  this.setLayout(gridbag);
  // And add the panels to the toplevel window
  constrains(this, butPanel, 0, 0, 2, 1, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST, 0.0, 0.0, 10, 0, 0, 0);
  constrains(this, lblPanel, 0, 1, 2, 1, GridBagConstraints.BOTH, GridBagConstraints.CENTER, 0.0, 0.0, 10, 0, 10, 0);
  constrains(this, folderPanel, 0, 2, 2, 1, GridBagConstraints.BOTH, GridBagConstraints.CENTER, 0.0, 0.0, 10, 0, 10, 0);
  constrains(this, queryPanel, 0, 3, 2, 1, GridBagConstraints.BOTH, GridBagConstraints.CENTER, 0.0, 0.0, 10, 0, 10, 0);

  this.pack();
  this.show();
}

public void constrains(Container container, Component component,
	int grid_x, int grid_y, int grid_width, int grid_height,
	int fill, int anchor, double weight_x, double weight_y,
	int top, int left, int bottom, int right)
  {
    GridBagConstraints c = new GridBagConstraints();
    c.gridx = grid_x; c.gridy = grid_y;
    c.gridwidth = grid_width; c.gridheight = grid_height;
    c.fill = fill; c.anchor = anchor;
    c.weightx = weight_x; c.weighty = weight_y;
    if (top+bottom+left+right > 0)
      c.insets = new Insets(top, left, bottom, right);
    
    ((GridBagLayout)container.getLayout()).setConstraints(component, c);
    container.add(component);
  }
  
public void constrains(Container container, Component component,
	int grid_x, int grid_y, int grid_width, int grid_height) {
  constrains(container, component, grid_x, grid_y,
	    grid_width, grid_height, GridBagConstraints.NONE,
	    GridBagConstraints.NORTHWEST, 0.0, 0.0, 0, 0, 0, 0);
}
  
public void constrains(Container container, Component component,
	int grid_x, int grid_y, int grid_width, int grid_height,
	int top, int left, int bottom, int right) {
  constrains(container, component, grid_x, grid_y,
	    grid_width, grid_height, GridBagConstraints.NONE,
	    GridBagConstraints.NORTHWEST,
	    0.0, 0.0, top, left, bottom, right);
}

  //public boolean action(Event eve, Object what) {
  public boolean handleEvent(Event eve) {
  if(eve.id == Event.MOUSE_ENTER) {
    if(eve.target == savemail) {
      butDesc.setText("Save Mail in specified folder......");
    }
    else if(eve.target == okfr) {
      butDesc.setText("Close frame......");
    }
  }
  if(eve.id == Event.MOUSE_EXIT) {
    if((eve.target == savemail) || (eve.target == okfr)){
      butDesc.setText("Frame to save mail to a specific folder...");
    }
  }
  if(eve.target instanceof Button) {
    if(eve.arg.equals(" Yes ")) {
      fldrResponse.setText("Message saved in '"+FolderName+"' and marked deleted");
      String name = editor.lp.mailIndex.getItem(editor.mail_index);
      name = "D" + name.substring(1);
      editor.lp.mailIndex.replaceItem(name,editor.mail_index);
      int mail_no = editor.mail_index + 1;
      out.println("DELETE "+ mail_no);
      out.println("FOLDERNAME "+ FolderName); 
      out.println("SAVE "+ mail_no);
      newFolderCreated = true;
      editor.bp.fop.defaultsPanel.fldr_choice.addItem(FolderName);
      editor.bp.fop.cabinetPanel.cabIndex.addItem("/home/B8F/furma/mail/"+FolderName);      
      return true;
    }
    else if(eve.arg.equals(" No ")) {
      fldrResponse.setText("Save message cancelled");
      return true;
    }
  }
  if(eve.id == Event.MOUSE_DOWN) { 
    if(eve.target == okfr) {
      this.hide();
      this.dispose();
      return true;
    }
    else if(eve.target == savemail) {
      FolderName = tf1.getText();
      System.out.println("folder doesn't exist");
      fldrResponse.show(true);
      fldrResponse.setText("Folder '"+FolderName+"' doesn't exist. Create new folder?");
      yes_but.show(true);
      no_but.show(true);
      this.pack();
      this.show();
      //If yes, then send the foldername and msg no. to Server.java
      return true;
    }
  }
  return false;
  }
}

