/*
 * @(#)UNIXUserEnumeration.c	1.2 97/03/03
 * 
 * Copyright (c) 1995-1997 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.0
 */


#include	<pwd.h>

#include	"sun_server_realm_UNIXUserEnumeration.h"


/*
 * Native methods supporting the enumeration of user names.
 *
 * This uses the standard UNIX/POSIX calls for accessing
 * such names.  Most systems also have APIs for modifying
 * the database of such user acounts, but they're not at
 * all portable.
 */

void sun_server_realm_UNIXUserEnumeration_setpwent (
    struct Hsun_server_realm_UNIXUserEnumeration	*this
)
{
    /*
     * NOTE:  the POSIX (and even Solaris) APIs have a flaw in
     * that they only allow one such enumeration to go on in a
     * process at a time ... we really can't do anything about
     * it in a robust way.  Problem #1 is telling when "the"
     * active enumeration is done, so we could allow another.
     */
    setpwent ();
}


struct Hjava_lang_String *
sun_server_realm_UNIXUserEnumeration_getNextUserName (
    struct Hsun_server_realm_UNIXUserEnumeration	*this
)
{
    char		buf [BUFSIZ];
    struct passwd	value;

    if (getpwent_r (&value, buf, sizeof buf) == 0)
	return 0;

    return makeJavaString (value.pw_name, strlen (value.pw_name));
}
