/*
 * @(#)DBDataEncoder.java	1.8 97/03/03
 * 
 * Copyright (c) 1995-1997 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.0
 */

import java.servlet.*;

/**
 * DBDataEncoder
 * This is an abstract class that should be inherited by data
 * encoder/decoder classes
 * 
 * @author   Scott Atwood
 * @author   Jongyoon Lee
 * @version  1.8, 03/03/97
 */

public abstract class DBDataEncoder {

    ServletOutputStream out;


    public DBDataEncoder(ServletOutputStream out) {
	this.out = out;
	sendVersionInfo();
    }

    public abstract boolean write(Object obj);

    public abstract void sendVersionInfo();
}

