/*
 * @(#)DBDataSimpleEncoder.java	1.8 97/03/03
 * 
 * Copyright (c) 1995-1997 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.0
 */

import java.servlet.ServletOutputStream;

/**
 * DBDataSimpleEncoder
 * Sends everything in String.  Works well if the data is in text format only.
 * 
 * @author   Scott Atwood
 * @author   Jongyoon Lee
 * @version  1.8, 03/03/97
 */

public class DBDataSimpleEncoder extends DBDataEncoder {


    public DBDataSimpleEncoder(ServletOutputStream out) {
	super(out);
    }

    public boolean write(Object obj) {
	try {
	    out.println(obj.toString());
	} catch (Exception e) {
	    return false;
	}
	return true;
    }

    public void sendVersionInfo() {
	try {
	    out.println("SimpleEncoder V 1.0");
	} catch (Exception e) {}
    }
}

