/*
 * @(#)RoomSchedServlet.java	1.11 97/03/03
 * 
 * Copyright (c) 1995-1997 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.0
 */

import java.io.*;
import java.net.*;
import java.util.*;
import java.net.InetAddress;
import java.servlet.*;
import java.servlet.http.*;
import sun.net.smtp.SmtpClient;

/*
 * Conference Room Scheduler servlet
 * @author  Rob Clark
 */

public class RoomSchedServlet extends HttpServlet {

    static final String NA = "empty-na";
    static Hashtable times = new Hashtable();

    static {
	times.put("0", "8:00am");
	times.put("1", "8:30am");
	times.put("2", "9:00am");
	times.put("3", "9:30am");
	times.put("4", "10:00am");
	times.put("5", "10:30am");
	times.put("6", "11:00am");
	times.put("7", "11:30am");
	times.put("8", "12:00pm");
	times.put("9", "12:30pm");
	times.put("10", "1:00pm");
	times.put("11", "1:30pm");
	times.put("12", "2:00pm");
	times.put("13", "2:30pm");
	times.put("14", "3:00pm");
	times.put("15", "3:30pm");
	times.put("16", "4:00pm");
	times.put("17", "4:30pm");
	times.put("18", "5:00pm");
	times.put("19", "5:30pm");
	times.put("20", "6:00pm");
    }

    private void p(String s) {
	//System.out.println(s);
    }

    public void service(HttpServletRequest req, HttpServletResponse res)
	throws IOException
    {

	ServletOutputStream out = res.getOutputStream();
	ServletContext servletContext = getServletContext();

	int i;
	int month = Integer.parseInt(req.getParameter("month"));
	int day = Integer.parseInt(req.getParameter("day"));
	int year = Integer.parseInt(req.getParameter("year"));
	String action = req.getParameter("action");

	// resolve this against Doc root.
	String CalName = req.getRealPath("sunw/server/calendar/cal" +
					 month + day + year + ".dat");
	RandomAccessFile fil = new RandomAccessFile(CalName, "rw");
	String entries[] = new String[21];
	String requestors[] = new String[21];
	String attendeesList[] = new String[21];
	String buf;

	/* Read in the calendar data file */
	for (i=0; i<=20; i++) {
	    if (fil.getFilePointer() < fil.length()) {
		requestors[i] = fil.readLine();
		if (requestors[i].equals(NA)) {
		    entries[i] = NA;
		    p("Reading " + i + NA);
		} else {
		    attendeesList[i] = fil.readLine();
		    p("Reading " + i + attendeesList[i]);
		    entries[i] = fil.readLine();
		    p("Reading " + i + entries[i]);
		    buf = fil.readLine();
		    p("Reading " + i + buf);
		    while (!buf.equals(NA)) {
			entries[i] = entries[i].concat("\n" + buf);
			p("Buf becomes \"" + entries + "\"");
			buf = fil.readLine();
		    }
		}
	    } else {
		entries[i] = NA;
	    }
	}

	res.setContentType("text/html");

	if (action.equals("get")) {
	    sendEntries(entries, requestors, attendeesList, out);
	    fil.close();
	    return;
	}

	String entry = req.getParameter("entry");
	int start = Integer.parseInt(req.getParameter("starttime"));
	int end = Integer.parseInt(req.getParameter("endtime"));
	String attendees = req.getParameter("attendees");
	String requestor = req.getParameter("requestor");

	boolean insert = true;
	Date date = new Date(year, month, day, 8, 0);

	if (start>=end) {
	    sendEntries(entries, requestors, attendeesList, out);
	    fil.close();
	    return;
	}
	p("adding entry!");
	if (action.equals("add")) {
	    /* Make sure all times are available */
	    //p("Start is " + start + " End is " + end);
	    for (i=start; i<end; i++) {
		p("Entry is " + entries[i]);
		if (!entries[i].equals(NA)) {
		    insert=false;
		}
	    }
	}

	//p("Insert is: " + insert);
	if (insert) {
	    i=0;
	    while (i<=20) {
		if (i==start) {
		    while (i<end) {
			requestors[i] = requestor;
			attendeesList[i] = attendees;
			entries[i] = entry;
			i++;
		    }
		}
		i++;
	    }

	    // update the file
	    fil.seek(0);
	    for (i=0; i<=20; i++) {
		if (!entries[i].equals(NA)) {
		    fil.writeBytes(requestors[i] + "\n");
		    fil.writeBytes(attendeesList[i] + "\n");
		    fil.writeBytes(entries[i] + "\n");
		    p("writing entry" + requestors[i] + attendeesList[i] + entries[i]);
		}
		fil.writeBytes(NA + "\n");
	    }

	    // Mail the users a confirmation
	    if (!attendees.equals("none")) {
		int index = entry.indexOf('\n');
		String header = (index == -1) ?
		    entry : entry.substring(0, index);
		String email =
		    new String("\n\n" +
			       "\t** Calendar Appointment **\n\n" +
			       "\tDate:\t" + (date.getMonth() + 1) + "/" + date.getDate() + "/" + date.getYear() + "\n" +
			       "\tStart:\t" + (String) times.get(String.valueOf(start)) + "\n" +
			       "\tEnd:\t" + (String) times.get(String.valueOf(end)) + "\n" +
			       "\tWhat:\t" + header + "\n\n");
		//MailUsers(attendees, email, requestor);
	    }
	}

	fil.close();
	sendEntries(entries, requestors, attendeesList, out);
    }


    private void sendEntries(String[] entry, String[] req, String[] att,
			     OutputStream out) {
	//p("Sending entries");
	DataOutputStream dos = new DataOutputStream(out);
	for (int i = 0; i < entry.length; i++) {
	    try {
		if (!entry[i].equals(NA)) {
		    dos.writeBytes(req[i]+"\n");
		    dos.writeBytes(att[i]+"\n");
		    dos.writeBytes(entry[i]+"\n");
		    p("Sending " + i + req[i]);
		    p("Sending " + i + att[i]);
		    p("Sending " + i + entry[i]);
		}
		dos.writeBytes(NA + "\n");
	    } catch (IOException e) {
		e.printStackTrace();
		return;
	    }
	}
    }


    public void MailUsers(String users, String email, String requestor)
	throws IOException
    {
 
	PrintStream ps = null;
	SmtpClient sendmail = null;
	try {
	    // open smtp connection
	    sendmail = new SmtpClient(InetAddress.getLocalHost().getHostName());
	    sendmail.from(requestor);
	    sendmail.to(users);
	    // get printstream
	    ps = sendmail.startMessage();
	    // send headers.
	    ps.println("From: "+ requestor);
	    ps.println("To: " + users);
	    ps.println("Subject: Appointment Reminder");
	    ps.print("\r\n"); //header area delimiter
	    // now send data to it
	    ps.println(email);
	    ps.println();
	    ps.println("(email was generated by Jeeves Conference Room Scheduler).");
	    ps.flush();
	    ps.close();
	    sendmail.closeServer();
	} catch (Exception e) {
	    e.printStackTrace();
	    return;
	}	    
    }


    public String getServletInfo() {
	return "This servlet maintains a bulletin board on a server.";
    }

}

