/*
 * @(#)EchoServlet.java	1.2 97/03/03
 * 
 * Copyright (c) 1995-1997 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.0
 */


// Simple JavaIDL Jeeves servlet.  Listens to incoming requests on port
// 4490 and echos the input.

import echo.*;
import java.servlet.*;
import java.io.*;

public
class EchoServlet extends GenericServlet {

    public void init() {

	// We use port 4490 to accept incoming Java-java connections.
	sunw.door.Orb.initialize(4490);

	// Create and publish an echo IDL objRef.
	try {
	    // The EchoSkeleton was created by the IDL compiler
	    EchoRef echo = EchoSkeleton.createRef(new EchoImpl());
	    sunw.door.Orb.publish("echo", echo);
	} catch (Exception ex) {
	    System.err.println("Couldn't bind object in naming context: " + ex);
	    ex.printStackTrace();
	    return;
	}
	System.err.println("setup and bound Echo server object OK");

    }

    // When an http request comes in for this servlet, return the
    // JavaIDL name for the echo object
    public void service(ServletRequest req, ServletResponse res) 
    {
	res.setContentType("text/plain");
	String hostname;
	PrintStream out = new PrintStream(res.getOutputStream());
        try {
	    hostname = java.net.InetAddress.getLocalHost().getHostName();
	} catch (Exception ex) {
	    out.println("Couldn't get hostname: " + ex);
	    ex.printStackTrace();
	    return;
	}
	out.println("idl:sunw.door://" + hostname + ":4490/echo");
    }

    public String getServletInfo() 
    {
      return "This example servlet acts as a JavaIDL server";
    }
}

