/*
 * @(#)CounterRMIServlet.java	1.7 97/03/03
 * 
 * Copyright (c) 1995-1997 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.0
 */

package rmiexample;

import java.io.IOException;

import java.rmi.registry.*;
import java.rmi.server.UnicastRemoteObject;
import java.rmi.*;

import java.servlet.*;

public class CounterRMIServlet
	extends UnicastRemoteObject
	implements Counter, Servlet
{
    private int num = 0;

static {
    if (System.getSecurityManager() == null) {
	System.out.println("security manager is null in main");
	System.setSecurityManager(new RMISecurityManager());
    }
}
    
// Counter & RMI methods
    public CounterRMIServlet() throws RemoteException
    {
	System.out.println("construct");
    }
     
    public void noop() throws RemoteException
    {
    }

    public synchronized int reset() {
	System.out.println("reset");
	int v = num;
	num = 0;
	return v;
    }

    public synchronized int inc() {
	num++;
	System.out.println("num: "+num);
	return num;
    }

// servlet support
    private ServletConfig conf;
    public void init(ServletConfig conf) throws ServletException {
	System.out.println("init with config");
	this.conf = conf;
	init();
    }

    public void init() throws ServletException {
	System.out.println("init");
 	log("init");
	try {
	    String hostname = java.net.InetAddress.getLocalHost().getHostName();
	    hostname = "//" + hostname + "/servletcounter";
	    Naming.rebind(hostname, this);
	} catch (Exception e) {
	    e.printStackTrace();
	}
    }

    public ServletConfig getServletConfig() {
	return conf;
    }

    public ServletContext getServletContext() {
	return conf.getServletContext();
    }

    public String getInitParameter(String name) {
	return conf.getInitParameter(name);
    }

    public void log(String msg) {
	getServletContext().log(msg);
    }

    public String getServletInfo() {
	return "This is a sample RMI server / Jeeves servlet";
    }

    public void service(ServletRequest req, ServletResponse res) 
    throws ServletException, IOException {
	res.getOutputStream().print("" + inc());
    }

    public void destroy() {
	log("destroy");
    }
}
