/*
 * @(#)ServletConfig.java	1.11 97/03/03
 * 
 * Copyright (c) 1995-1997 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.0
 */

package java.servlet;

import java.util.Enumeration;

/**
 * This interface is used by the server to pass configuration information
 * to a servlet when it is first loaded. It contains methods to get the
 * context in which the servlet is running, as well as any initialization
 * parameters that may have been being passed to the servlet at startup.
 *
 * @version     1.11, 03/03/97
 * @author      David Connelly
 */
public
interface ServletConfig {
    /**
     * Returns the context for the servlet.
     */
    public ServletContext getServletContext();

    /**
     * Gets an initialization parameter of the servlet.
     * @param name the parameter name
     */
    public String getInitParameter(String name);

    /**
     * Returns an enumeration of strings representing the initialization
     * parameters for this servlet.
     */
    public Enumeration getInitParameterNames();
}
