/*
 * @(#)HttpServlet.java	1.6 97/03/03
 * 
 * Copyright (c) 1995-1997 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.0
 */

package java.servlet.http;

import java.servlet.GenericServlet;
import java.servlet.ServletRequest;
import java.servlet.ServletResponse;
import java.servlet.ServletException;
import java.io.IOException;

/**
 * Convenience class for implementing HTTP specific servlets.
 *
 * @version     1.6, 03/03/97
 * @author	David Connelly
 */
public abstract
class HttpServlet extends GenericServlet {

    /**
     * Services a single request from the client.
     * @param req the servlet request
     * @param res the servlet response
     * @exception ServletException if a servlet exception has occurred
     * @exception IOException if an I/O exception has occurred
     */
    public void service(ServletRequest req, ServletResponse res)
	throws ServletException, IOException
    {
	try {
	    service((HttpServletRequest)req, (HttpServletResponse)res);
	} catch (ClassCastException e) {
	    throw new ServletException("not HTTP servlet");
	}
    }

    /**
     * Services a single HTTP request from the client.
     * @param req the HTTP servlet request
     * @param res the HTTP servlet response
     * @exception ServletException if a servlet exception has occurred
     * @exception IOException if an I/O exception has occurred
     */
    public abstract void service(HttpServletRequest req,
				 HttpServletResponse res)
	throws ServletException, IOException;
}
