package npac.webmail;

public class AddressFormat {
  private String personalName;
  private String atDomainList;
  private String mailboxName;
  private String hostName;

  public String getPersonalName () { return personalName; }
  public String getAtDomainList () { return atDomainList; }
  public String getMailboxName () { return mailboxName; }
  public String getHostName () { return hostName; }

  public void setPersonalName ( String s ) { personalName = s; }
  public void setAtDomainList ( String s ) { atDomainList = s; }
  public void setMailboxName ( String s ) { mailboxName = s; }
  public void setHostName ( String s ) { hostName = s; }

  public String toString () {
    if (personalName.equals(""))
      return mailboxName + "@" + hostName;
    else 
      return "\"" + personalName + "\" <" + mailboxName + "@" + hostName + ">";
  }

  public AddressFormat ( ) {
    personalName = atDomainList = mailboxName = hostName = "";
  }

  public AddressFormat ( String p, String a, String m, String h ) {
    personalName = p;
    atDomainList = a;
    mailboxName = m;
    hostName = h;
  }

  public AddressFormat ( String s ) {
    IMAP2bisFilter addrFil = new IMAP2bisFilter ( s );
    String tok1 = addrFil.filter();
    String tok2 = addrFil.filter();
    String tok3 = addrFil.filter();
    String tok4 = addrFil.filter();

    personalName = tok1.equals("NIL") ? "" : tok1;
    atDomainList = tok2.equals("NIL") ? "" : tok2;
    mailboxName = tok3.equals("NIL") ? "" : tok3;
    hostName = tok4.equals("NIL") ? "" : tok4;
  }

}
