package npac.webmail;

public class IMAP2bisFilter 
{
  private String localStr = "";
  private int currBeg = -1;
  private int beg = -1;
  private int end = -1;
  private boolean escape = false;

  public IMAP2bisFilter ( String s ) {
    localStr = s;
    currBeg = 0;
    beg = 0;
    end = localStr.length();
  }

  public String filter () {
    String returnStr = "";

    if ( currBeg >= end )
      return null;
    while ( currBeg<end && (localStr.charAt(currBeg) == ' ') )
      currBeg++;
    if ( localStr.charAt(currBeg) == '"' ) {
      int i = currBeg+1;
      while ( i<end && (localStr.charAt(i) != '"') && !escape ) {
	if (localStr.charAt(i) == '\\') {
	  if (!escape)
	    escape = true;
	  else if (escape)
	    escape = false;
	}
	else
	  if (escape)
	    escape = false;
	i++;
      }
      returnStr = localStr.substring ( currBeg+1, i );
      currBeg = i+1;
      return returnStr;
    }
    else if ( localStr.charAt(currBeg) == '(' ) {
      int i = currBeg+1;
      int level = 0;
      while ( i<end && ((localStr.charAt(i) != ')') || (level != 0)) ) {
	if (localStr.charAt(i) == '(')
	  level++;
	if (localStr.charAt(i) == ')')
	  level--;
	i++;
      }
      returnStr = localStr.substring ( currBeg+1, i );
      currBeg = i+1;
      return returnStr;      
    }
    else {
      int i = currBeg;
      while ( i<end && (localStr.charAt(i) != ' ') )
	i++;
      returnStr = localStr.substring ( currBeg, i );
      currBeg = i+1;
      return returnStr;      
    }
  }
}

