package npac.webmail;

import java.util.*;

public class IndexFormat {
  private AddressFormat[] from;
  private String date[];
  private String subject[];
  private String messageSize[];
  private int numTotal;
  private int numNew;
  private int numUnread;
  private int numAnswered;
  private int numDeleted;

  private boolean isAnswered[], isFlagged[], isDeleted[], isSeen[];

  public AddressFormat[] getFrom () { return from; }
  public AddressFormat getFrom ( int i ) { return from[i]; }
  public String[] getDate () { return date; }
  public String getDate ( int i ) { return date[i]; }
  public String[] getSubject () { return subject; }
  public String getSubject ( int i ) { return subject[i]; }
  public String[] getMessageSize () { return messageSize; }
  public String getMessageSize ( int i ) { return messageSize[i]; }
  public boolean[] getIsAnswered () { return isAnswered; }
  public boolean getIsAnswered ( int i ) { return isAnswered[i]; }
  public boolean[] getIsFlagged () { return isFlagged; }
  public boolean getIsFlagged ( int i ) { return isFlagged[i]; }
  public boolean[] getIsDeleted () { return isDeleted; }
  public boolean getIsDeleted ( int i ) { return isDeleted[i]; }
  public boolean[] getIsSeen () { return isSeen; }
  public boolean getIsSeen ( int i ) { return isSeen[i]; }

  public void setFrom ( AddressFormat[] a ) { from = a; }
  public void setFrom ( int i, AddressFormat a ) {  from[i] = a; }
  public void setFrom ( Vector v ) { from = new AddressFormat[v.size()]; v.copyInto ( from ); }
  public void setDate ( String[] s ) { date = s; }
  public void setDate ( Vector v ) { date = new String[v.size()]; v.copyInto ( date ); }
  public void setDate ( int i, String s ) { date[i] = s; }
  public void setSubject ( String[] s ) { subject = s; }
  public void setSubject ( Vector v ) { subject = new String[v.size()]; v.copyInto ( subject ); }
  public void setSubject ( int i, String s ) { subject[i] = s; }
  public void setMessageSize ( String[] s ) { messageSize = s; }
  public void setMessageSize ( Vector v ) { messageSize = new String[v.size()]; v.copyInto ( messageSize ); }
  public void setMessageSize ( int i, String s ) { messageSize[i] = s; }
  public void setIsAnswered ( boolean[] b ) { isAnswered = b; }
  public void setIsAnswered ( Vector v ) {
    isAnswered = new boolean[v.size()];
    for (int i=0; i<v.size(); i++ )
      isAnswered[i] = ((Boolean)v.elementAt(i)).booleanValue();
  }
  public void setIsAnswered ( int i, boolean b ) { isAnswered[i] = b; }
  public void setIsFlagged ( boolean[] b ) { isFlagged = b; }
  public void setIsFlagged ( Vector v ) {
    isFlagged = new boolean[v.size()];
    for (int i=0; i<v.size(); i++ )
      isFlagged[i] = ((Boolean)v.elementAt(i)).booleanValue();
  }
  public void setIsFlagged ( int i, boolean b ) { isFlagged[i] = b; }
  public void setIsDeleted ( boolean[] b ) { isDeleted = b; }
  public void setIsDeleted ( Vector v ) {
    isDeleted = new boolean[v.size()];
    for (int i=0; i<v.size(); i++ )
      isDeleted[i] = ((Boolean)v.elementAt(i)).booleanValue();
  }
  public void setIsDeleted ( int i, boolean b ) { isDeleted[i] = b; }
  public void setIsSeen ( boolean[] b ) { isSeen = b; }
  public void setIsSeen ( Vector v ) {
    isSeen = new boolean[v.size()];
    for (int i=0; i<v.size(); i++ )
      isSeen[i] = ((Boolean)v.elementAt(i)).booleanValue();
  }
  public void setIsSeen ( int i, boolean b ) { isSeen[i] = b; }

  public int getNumTotal () { return numTotal; }
  public void setNumTotal (int i) { numTotal = i; }
  public void incrNumTotal () { numTotal++; }
  public void decrNumTotal () { numTotal--; }

  public int getNumUnread () { return numUnread; }
  public void setNumUnread (int i) { numUnread = i; }
  public void incrNumUnread () { numUnread++; }
  public void decrNumUnread () { numUnread--; }

  public int getNumAnswered () { return numAnswered; }
  public void setNumAnswered (int i) { numAnswered = i; }
  public void incrNumAnswered () { numAnswered++; }
  public void decrNumAnswered () { numAnswered--; }

  public int getNumNew () { return numNew; }
  public void setNumNew (int i) { numNew = i; }
  public void incrNumNew () { numNew++; }
  public void decrNumNew () { numNew--; }

  public int getNumDeleted () { return numDeleted; }
  public void setNumDeleted (int i) { numDeleted = i; }
  public void incrNumDeleted () { numDeleted++; }
  public void decrNumDeleted () { numDeleted--; }

  public String toString () {
    String str="";
    for (int i=0; i<numTotal; i++)
      str += "[" + (isAnswered[i] ? "A" : "_") + (isFlagged[i] ? "F" : "_") + (isDeleted[i] ? "D" : "_") + (isSeen[i] ? "_" : "N") + "] [" + (i+1) + "]  [" + date[i] + "]  [" + from[i] + "]  [" + messageSize[i] + "]  [" + subject[i] + "]";
    return str;
  }

  public IndexFormat ( int n ) {
    numUnread = numTotal = n;
    numAnswered = numNew = numDeleted = 0;
    from = new AddressFormat[numTotal];
    date = new String[numTotal];
    subject = new String[numTotal];
    messageSize = new String[numTotal];
    isAnswered = new boolean[numTotal];
    isFlagged = new boolean[numTotal];
    isDeleted = new boolean[numTotal];
    isSeen =  new boolean[numTotal];
    for (int i=0; i<numTotal; i++) {
      date[i] = subject[i] = messageSize[i] = "";
      isAnswered[i] = isFlagged[i] = isDeleted[i] = isSeen[i] = false;
    }
  }    
}
