import java.io.*;
import java.net.*;

public class MyServer extends Thread {

     public final static int DEFAULT_PORT = 6767;
     protected int port;
     protected ServerSocket listen_socket;

     public static void fail(Exception e, String msg)  {
	System.err.println(msg + ":" + e );
	System.exit(1);
     }

     public MyServer(int port) {
	if (port==0) 
           port=DEFAULT_PORT;        
	this.port = port;
        try { listen_socket = new ServerSocket(port);}
        catch (IOException e) fail(e,"Exception creating server socket");
        this.start();
     }

     public void run() {
	try {
	   while(true) {
	      Socket client_socket = listen_socket.accept();
	      Connection c = new Connection(client_socket);
           }
        }
       catch(IOException e)fail(e,"Exception while listening for connections");
     }

     public static void main(String[] args)  {      
	int port = 0;
        if(args.length == 1) {
	   try port = Integer.parseInt(args[0]);
           catch (NumberFormatException e) port =0;
        }
        new MyServer(port);
      }
 }

 class Connection extends Thread {

     protected Socket client;
     protected DataInputStream in;
     RandomAccessFile sourcefile ;
     String line;

        public Connection(Socket client_socket) {
	  client = client_socket;
     try {sourcefile = new RandomAccessFile("experiences.html","rw");}
      catch(IOException e5)System.err.println(
                 "Exception while creating RandomAccessFile" + e5);
          try { in = new DataInputStream(client.getInputStream());}  	
	  catch(IOException e) {
             try client.close(); 
	     catch(IOException e2);
	     System.err.println("Exception while getting socket streams:"+e);
	     return;
	  }
    System.out.println("Information Received from: " + client.getInetAddress());
	    this.start();
        }

	public void run() {
	  
	  try  {
		for(;;) {
		 line = in.readLine();
                 if(line==null) break;
		 sourcefile.seek(sourcefile.length());
		 sourcefile.writeBytes("<li>");
		 sourcefile.writeBytes(line);
		 sourcefile.writeBytes("\n");
		}
		 sourcefile.writeBytes("\n");
	   }
	    catch(IOException e);
	    finally try client.close();
	    catch(IOException e2);
        }
   }      			
