package webmail.imap;

import java.util.*;

public class MailFormat {
  private AddressFormat from, sender, replyTo;
  private AddressFormat[] to, cc, bcc;
  private String internalDate, date;
  private String subject;
  private String messageSize, msgId, inReplyTo;
  private String[] messageBody;

  private boolean isAnswered, isFlagged, isDeleted, isSeen;

  public AddressFormat getFrom () { return from; }
  public AddressFormat getSender () { return sender; }
  public AddressFormat getReplyTo () { return replyTo; }
  public AddressFormat[] getTo () { return to; }
  public AddressFormat[] getCc () { return cc; }
  public AddressFormat[] getBcc () { return bcc; }
  public String getInternalDate () { return internalDate; }
  public String getDate () { return date; }
  public String getSubject () { return subject; }
  public String getMessageSize () { return messageSize; }
  public String getMsgId () { return msgId; }
  public String getInReplyTo () { return inReplyTo; }
  public boolean getIsAnswered () { return isAnswered; }
  public boolean getIsFlagged () { return isFlagged; }
  public boolean getIsDeleted () { return isDeleted; }
  public boolean getIsSeen () { return isSeen; }
  public String[] getMessageBody () { return messageBody; }
  
  public void setFrom ( AddressFormat a ) {  from = a; }
  public void setSender ( AddressFormat a ) { sender = a; }
  public void setReplyTo ( AddressFormat a ) { replyTo = a; }
  public void setTo ( AddressFormat[] s ) { to = s; }
  public void setTo ( Vector v ) { to = new AddressFormat[v.size()]; v.copyInto ( to ); }
  public void setCc ( AddressFormat[] s ) { cc = s; }
  public void setCc ( Vector v ) { cc = new AddressFormat[v.size()]; v.copyInto ( cc ); }
  public void setBcc ( AddressFormat[] s ) { bcc = s; }
  public void setBcc ( Vector v ) { bcc =  new AddressFormat[v.size()]; v.copyInto ( bcc ); }
  public void setInternalDate ( String s ) { internalDate = s; }
  public void setDate ( String s ) { date = s; }
  public void setSubject ( String s ) { subject = s; }
  public void setMessageSize ( String s ) { messageSize = s; }
  public void setMsgId ( String s ) { msgId = s; }
  public void setInReplyTo ( String s ) { inReplyTo = s; }
  public void setIsAnswered ( boolean b ) { isAnswered = b; }
  public void setIsFlagged ( boolean b ) { isFlagged = b; }
  public void setIsDeleted ( boolean b ) { isDeleted = b; }
  public void setIsSeen ( boolean b ) { isSeen = b; }
  public void setMessageBody ( String[] sArr ) { messageBody = sArr; }
  public void setMessageBody ( Vector v ) { messageBody = new String[v.size()]; v.copyInto ( messageBody ); }

  public void appendMessageBody ( String s ) {
    messageBody[messageBody.length] = s;
  }

  public void print () {
    System.out.println ( );
    System.out.println ( "From: " + from );
    System.out.println ( "Sender: " + sender );
    System.out.println ( "ReplyTo: " + replyTo );
    { int i;
      System.out.print ( "To: " );
      for (i=0; i<to.length-1; i++)
	System.out.print ( to[i].value() + ", " );
      if (to.length>0)
	System.out.println ( to[to.length-1].value() );
      else System.out.println ();
    }
    { int i;
      System.out.print ( "Cc: " );
      for (i=0; i<cc.length-1; i++)
	System.out.print ( cc[i].value() + ", " );
      if (cc.length>0)
	System.out.println ( cc[cc.length-1].value() );
      else System.out.println ();
    }
    { int i;
      System.out.print ( "Bcc: " );
      for (i=0; i<bcc.length-1; i++)
	System.out.print ( bcc[i].value() + ", " );
      if (bcc.length>0)
	System.out.println ( bcc[bcc.length-1].value() );
      else System.out.println ();
    }
    System.out.println ( "InternalDate: " + internalDate );
    System.out.println ( "Date: " + date );
    System.out.println ( "Subject: " + subject );
    System.out.println ( "MessageSize: " + messageSize );
    System.out.println ( "MsgID: " + msgId );
    System.out.println ( "InReplyTo: " + inReplyTo );
    System.out.println ( "IsAnswered: " + isAnswered );
    System.out.println ( "IsFlagged: " + isFlagged );
    System.out.println ( "IsDeleted: " + isDeleted );
    System.out.println ( "IsSeen: " + isSeen );
//    for (int i=0; i<messageBody.length; i++)
//      System.out.println ( "Line " + i + " >> " + messageBody[i] );
  }

  public MailFormat ( ) {
    // Cannot initialize "from", "sender", "replyTo", "to", "cc" and "bcc"
    //                   taken care of in the setXxx fns.
    internalDate = date = "";
    subject = "";
    messageSize = msgId = inReplyTo = "";
    // Cannot initialize "messageBody", taken care of in the setMessageBody().
    isAnswered = isFlagged = isDeleted = isSeen = false;
  }    
}
