import java.applet.*;
import java.awt.*;
import java.io.*;
import java.net.*;
import java.util.*;

public class NBarApplet extends Applet {
  NBarConfig config;
  NBarPanel panel;

  public void init() {
    config = new NBarConfig(this);
    panel = new NBarPanel(config);
    setBackground(new Color(config.appletBgColor));
    add(panel);
  }
}

class NBarPanel extends Panel {
  NBarConfig c;
  IconPanel ip;
  CardPanel cp;

  NBarPanel(NBarConfig c) {
  this.c = c;
  setLayout(new BorderLayout());
  ip = new IconPanel(c);
  add("North",ip);
  cp = new CardPanel(c);
  add("South",cp);
}

public boolean handleEvent(Event e) {
if(e.target instanceof IconCanvas) {
  NBarItem it = (NBarItem)e.arg;
  switch(e.id) {
  case Event.MOUSE_ENTER:
    cp.setMessage(it.desc);
    cp.showMessage(); 

  case Event.MOUSE_MOVE:
  cp.setMessage(it.desc);
  break; 

 case Event.MOUSE_EXIT:
 cp.showLocator();
 break;

 case Event.ACTION_EVENT:
 handleCmd(it);
 break;

default:
return super.handleEvent(e);
}
return true;
}
    else if(e.target instanceof LocatorPanel) {
      switch(e.id) {
      case Event.ACTION_EVENT:
	cp.setLocator((String)e.arg);
	handleLocator((String)e.arg);
	return true;

      default:
	return super.handleEvent(e);
      }
    }
return super.handleEvent(e);
}

public void handleCmd(NBarItem it) {
try {
  //URL u2 = new URL("http://koum.npac.syr.edu:3535/htmlV2/ListFolder.html");
   System.out.println("in handle command");
  URL u2 = new URL("http://koum.npac.syr.edu:3535/servlet/listfoldersV2");
  ((Applet)getParent()).getAppletContext().showDocument(u2, "list");
} catch(MalformedURLException e) {
  System.out.println(e);
  System.exit(1);
}
}

public void handleLocator(String spec) {
try {
  URL newURL = new URL(c.base, spec);	
  c.currURL = newURL;
  ((Applet)getParent()).getAppletContext().showDocument(newURL, "view");
} catch(MalformedURLException e) {
  System.out.println(e);
  System.exit(1);
}
}	
}

class NBarConfig {
  String configFile = "items.txt";
  int appletFgColor = 0x000000;
  int appletBgColor = 0xFFFFFF;
  int iconWidth = 32;
  int iconHeight = 32;
  int locatorCols = 80;
  int locatorFgColor = 0x000000;
  int locatorBgColor = 0xFFFFFF;
  Font locatorFont = new Font("Courier", Font.PLAIN, 10);
  int messageCols = 100;
  int messageFgColor = 0x000000;
  int messageBgColor = 0xFFFFFF;
  Font messageFont = new Font("Helvetica", Font.PLAIN, 12);
  URL base = null;
  URL currURL = null;
  NBarItem[] itv;
  Container parent;

  NBarConfig(Applet a) {
  parent = a;
  base = a.getDocumentBase();
  System.out.println(base.toString());
  currURL = base;
  configFile = getStringValue(a.getParameter("configFile"), configFile);
  appletFgColor = getHexValue(a.getParameter("appletFgColor"), appletFgColor);
  appletBgColor = getHexValue(a.getParameter("appletBgColor"), appletBgColor);
  iconWidth = getIntValue(a.getParameter("iconWidth"), iconWidth);
  iconHeight = getIntValue(a.getParameter("iconHeight"),iconHeight);
  locatorCols = getIntValue(a.getParameter("locatorCols"), locatorCols);
  locatorFgColor = getHexValue(a.getParameter("locatorFgColor"), locatorFgColor);
  locatorBgColor = getHexValue(a.getParameter("locatorBgColor"), locatorBgColor);
  locatorFont = getFontValue(a.getParameter("locatorFont"), locatorFont);
  messageCols = getIntValue(a.getParameter("messageCols"), messageCols);
  messageFgColor = getHexValue(a.getParameter("messageFgColor"), messageFgColor);
  messageBgColor = getHexValue(a.getParameter("messageBgColor"), messageBgColor);
  messageFont = getFontValue(a.getParameter("messageFont"), messageFont);	
  createItems(base);
}

NBarConfig(Frame f,String[] args) {
parent = f;
boolean isKey = true;
Hashtable t = new Hashtable();
String key = null;
for(int i=0; i<args.length; i++) {
  String s = args[i];
  if(isKey) { 
    if(s.charAt(0) == '-') {
      key = s.substring(1,s.length());
      isKey = false;
    }
    else {
      System.out.println("Syntax error: " + args[i]);
      System.exit(1);
    }
} else {
t.put(key,s);
isKey = true;
}
}
iconWidth = getIntValue((String)t.get("iconWidth"), 32);
iconHeight = getIntValue((String)t.get("iconHeigth"), 32);
locatorFont = getFontValue((String)t.get("locatorFont"), locatorFont);
messageFont = getFontValue((String)t.get("messageFont"), locatorFont);
//	createItems(new URL(System.getProperty("user.pwd")));


}

int getIntValue(String key, int def) {
  if(key == null) return def;
  return Integer.parseInt(key);
}

int getHexValue(String hex, int def) {
  if(hex == null) return def;
  return Integer.parseInt(hex,16);
}

String getStringValue(String key, String def) {
  return key == null ? def : key;
}  

Font getFontValue(String key, Font def) {
  if(key == null) return def; 
  else return Font.getFont(key);
}

void createItems(URL url) {
  Vector v = new Vector();
  URL items = null, imgURL = null;
  MediaTracker mt = null;
  String name = null, desc = null, line, imgFile = null;
  int id = 0;
  NBarItem it;

  try {
    
    items = new URL(base,"items.txt");
    DataInputStream  dis = new DataInputStream(items.openStream());
    mt = new MediaTracker(parent);
    while((line = dis.readLine()) != null) {
      StringTokenizer st = new StringTokenizer(line);
      try {
	name = st.nextToken();
	imgFile = st.nextToken();
      } 
      catch(NoSuchElementException e) {
	System.out.println(e);
	System.exit(1);
      }
      desc = dis.readLine();
      if(desc.length() > 0) {
	while(true) {
	  line = dis.readLine();
	  if(line.length() > 0) { desc += " " + line; }
	  else break;
	}
      }
      it = new NBarItem(id++, name, desc);
      v.addElement(it);
      imgURL = new URL(base,"icons/" + imgFile);
      it.on = Toolkit.getDefaultToolkit().getImage(imgURL);
      mt.addImage(it.on,1);
    }
} 
catch(MalformedURLException e) {
System.out.println("MalformedURLExceptione" + e);
System.exit(1);
}
catch(IOException e) {
System.out.println("IO Exception" + e);
System.exit(1);
}

try {
System.out.println("Loading Icons...");
mt.waitForID(1);
System.out.println("Done.");
if(mt.isErrorID(1)) {
  System.out.println("Media Tracker error");
  System.exit(1);
}
}
catch(InterruptedException e) {
System.out.println(e);
System.exit(1);
}

mt = null;
int cnt = v.size();
itv = new NBarItem[cnt];
for(int i = 0; i < cnt; i++) {
it = itv[i] = (NBarItem)v.elementAt(i);
it.setIcons(it.on);
}


}
}

class IconPanel extends Panel {
  NBarConfig c;
  IconCanvas ic;

  IconPanel(NBarConfig c) {
    this.c = c;
    ic = new IconCanvas(c);
    add(ic);
  }
}

class IconCanvas extends Canvas {
  NBarConfig c;
  NBarItem[] itv;
  int w, h;
  int lastDown = -1;

  IconCanvas(NBarConfig c) {
  this.c = c;
  itv = c.itv;
  w = c.iconWidth;
  h = c.iconHeight;
  resize(w*itv.length, h);
}

public void paint(Graphics g) {
NBarItem it;
for(int i=0; i<itv.length; i++) {
  it = itv[i];
  g.drawImage(it.on, i*w, 0, w, h, this);
}
}

public boolean handleEvent(Event e) {
int i = e.x/w;
i = Math.max(i,0);
i = Math.min(i,itv.length-1);
NBarItem it = itv[i];
Event ne;
switch(e.id) {
 case Event.MOUSE_DOWN:
  lastDown = i; 
  return true;

 case Event.MOUSE_UP:
  if(i != lastDown) return true;
  ne = new Event(this, Event.ACTION_EVENT, it);
  lastDown = -1;
  getParent().postEvent(ne);
  return true;

 case Event.MOUSE_ENTER:
 case Event.MOUSE_EXIT:
 case Event.MOUSE_MOVE:
  ne = new Event(this, e.id, it);
  getParent().postEvent(ne);
  return true;
}
return super.handleEvent(e);
}
}

class CardPanel extends Panel {
  static int LOCATOR = 0;
  static int MESSAGE = 1;
  static String[] cardNames = { "locator", "message" };

NBarConfig c;
CardLayout cl;
LocatorPanel lp;
MessagePanel mp;
int cardID = LOCATOR;

CardPanel(NBarConfig c) {
this.c = c;
setLayout(cl = new CardLayout());
lp = new LocatorPanel(c);
add("locator",lp);
mp = new MessagePanel(c);
add("message",mp);
}

public void showCard(int id) {
cardID = id;
cl.show(this,cardNames[cardID]);
}

public void showLocator() { 
showCard(LOCATOR); 
}

public void showMessage() { 
showCard(MESSAGE); 
}

public void setLocator(String s) {
lp.setValue(s);
}

public void setMessage(String s) {
mp.setValue(s);
}

public String getLocator() {
return lp.getValue();
}

}



class LocatorPanel extends Panel {
  NBarConfig c;
  TextField tf;

  LocatorPanel(NBarConfig c) {
  this.c = c;
  String path = c.base.getFile();
  tf = new TextField(path, c.locatorCols);
  tf.setFont(c.locatorFont);
  tf.setForeground(new Color(c.locatorFgColor));
  tf.setBackground(new Color(c.locatorBgColor));
  setLayout(new BorderLayout());
  add("North",tf);
}

public void setValue(String s) {
tf.setText(s);
}

public String getValue() {
return tf.getText();
}

public boolean action(Event e, Object obj) {
if(e.target == tf) {
  Event event = new Event(this, Event.ACTION_EVENT, tf.getText());
  getParent().postEvent(event);
  return true;
}
return false;
}
}

class MessagePanel extends Panel {
  NBarConfig c;
  Label label;

  MessagePanel(NBarConfig c) {
  this.c = c;
  label = new Label();
  label.setFont(c.messageFont);
  label.setForeground(new Color(c.messageFgColor));
  label.setBackground(new Color(c.messageBgColor));
  setForeground(Color.white);
  setLayout(new BorderLayout());
  add("North",label);
}

public void setValue(String s) {
label.setText(s);
}
}

class NBarItem {
  static int ON = 0;
  static int OFF = 1;
  static int BUSY = 2;
  static int FOCUS = 3;

  int id;
  String name;
  String desc;
  Image on, off, busy, focus;
  int state;

  NBarItem(int id, String name, String desc) {
  this.id = id;
  this.name = name;
  this.desc = desc;
}

public void setIcons(Image on, Image off, Image busy, Image focus) {
this.on = on;
this.off = off;
this.busy = busy;
this.focus = focus;
}

public void setIcons(Image on) {
setIcons(on, on, on, on);
}

public void setState(int state) {
this.state = state;
}

public void setOn() {
setState(ON);
}

public void setOff() {
setState(OFF);
}

public void setBusy() {
setState(BUSY);
}

public void setFocus() {
setState(FOCUS);
}

public int getState() {
return state;
}


}   

