//package webmail.version2;

import java.net.*;
import java.io.*;
import java.util.*;
import java.applet.*;
import npac.webmail.*;
//import webmail.version2.*;

public class Server extends Thread {

public final static int DEFAULT_PORT = 2345;
protected int port;
protected static ServerSocket listen_socket;
private static String name_of_folder;
private static FolderSuperclass fsc = null;
private static MailFormat mailf;
boolean condition = true;
private static boolean server_start = true;
Connection c; //new

public static void fail(Exception e, String msgg)  {
  System.err.println(msgg + ":" + e );
  System.exit(1);
}
     
  public Server(int port, String foldername, FolderSuperclass fsclass) {
  
  name_of_folder = foldername;
  fsc = fsclass;

  System.out.println("in server");
  if(server_start) {
    
    if (port==0)
      port=DEFAULT_PORT;
    this.port = port;
    try { 
      listen_socket = new ServerSocket(port);
    }
    catch (IOException e) {fail(e,"Exception creating server socket");}
    System.out.println("Server listening on port " + port);
    server_start = false;
  }
  this.start();
}

public void run() {
  try {
    while(condition) {
	Socket client_socket = listen_socket.accept();
	c = new Connection(client_socket, name_of_folder, fsc);
	System.out.println("Connection: "+ c);
    }
  }	
  catch(IOException e) {fail(e,"Exception while listening for connections");}
}	

public synchronized String [] getHeader() { 
  String[] h = Connection.getHead();     
  return h; 
}

public synchronized MailFormat getMailer() { 
  MailFormat mf = Connection.getMail();     
  return mf; 
}

public synchronized String [] getBody() {   
  String[] b = Connection.getBody();     
  return b; 
}

public synchronized String getSenderName() { return Connection.senderName; }
public synchronized String getSenderGif() { return Connection.senderGif; }
public synchronized String getLogoName() { return Connection.logoName; }
public synchronized String getLogoGif() { return Connection.logoGif; }
}

class Connection extends Thread {
  protected Socket client;
  protected DataInputStream in;
  protected PrintStream out;
  private static String FolderName;
  private static IndexFormat indexf;
  private static FolderSuperclass fsc;
  private static MailFormat mailf;
  static String senderName="";
  static String logoName="";
  static String senderGif="";
  static String logoGif="";
  static String header = "";
  static String body = "";
  static String date = "";
  static String sub = "";
  static String from = "";
  private static String[] head;
  private static String[] msg;
  private final static String[] name_array = {"shrideep", "afoxman", "gkhoury", "gult", "kipp", "prakash", "psycho"};
  private final static String[] logo_array = {"npac", "mcgill", "hscsyr", "jhu", "syr" };
  private static boolean headLock = true;
  private static boolean bodyLock = true;

  public Connection(Socket client_socket, String name, FolderSuperclass fsclass) {
    client = client_socket;
    FolderName = name;
    fsc = fsclass;
    indexf = fsc.index();
    headLock = true;

    try {
      in = new DataInputStream(client.getInputStream());
      out = new PrintStream(client.getOutputStream());
    }
    catch(IOException e) {
      try {client.close();}
      catch(IOException e2){
	System.err.println("Exception while getting socket streams:"+e);}
      return;
    }
    System.out.println("Information Received from: " + client.getInetAddress());
    this.start();
  }

  public static synchronized String[] getHead() { 
    while(headLock == true)
      ;
    return head; 
  }

  public static synchronized MailFormat getMail() { 
    while(headLock == true)
      ;
    return mailf; 
  }

  public static synchronized String[] getBody() { 
    //System.out.println("bodylock in getBody() is "+bodyLock);
    while(bodyLock == true)
      ;
    //for(int l=0; l<msg.length; l++) System.out.println("getBody() body in server :"+msg[l]);
    return msg; 
  }

  private void process_index() {   
    int total_mails = indexf.getNumTotal();
    int count = 1;
    String msg_state = "";
    out.println(total_mails);
    for(int i = 0; i < total_mails ; i++) {
      if(!indexf.getIsSeen(i)) msg_state = "N";
      else if(indexf.getIsAnswered(i)) msg_state = "A";
      else if(indexf.getIsDeleted(i)) msg_state = "D";
      else msg_state = "R";
      
      String msg_size = "(" + indexf.getMessageSize(i) + ")";
      String msg_subject = indexf.getSubject(i);
      
      AddressFormat af = indexf.getFrom(i);
      String from = af.getPersonalName();
      String date = indexf.getDate(i);
      StringTokenizer st = new StringTokenizer(date);
      String day =  (st.nextToken());
      String date1 = (st.nextToken());
      String month =  (st.nextToken());
      String msg_date = month + " " + date1;

      if((msg_date.length()) == 5) msg_date = msg_date + " ";
      if(count<10) msg_date = " " + msg_date;
      int name_diff = 28 - (from.length());
      for (int p = 0; p < name_diff; p++) from = from + " ";
      int size_diff = 7 - (msg_size.length());
      for (int q = 0; q < size_diff; q++) msg_size = msg_size + " ";
      
      out.println(msg_state + "  " + count + " " + msg_date + " " + from + "   " + msg_size + "  " + msg_subject);
      count = count + 1;
    }
  }

  private void send_folder_names() {
    String maildir = "/home/B8F/furma/mail/";
    File dirfile = new File(maildir);
    String entries[] = dirfile.list(null);
    int no_folders = entries.length;
    out.println(no_folders);
    for (int q=0; q<no_folders; q++)
      out.println(entries[q]);
    out.println("FolderName: " + FolderName);
  }
  
  synchronized void fillHead() {	    
    headLock = true;
    //    String replyTo = mailf.getReplyTo().value();
    String replyTo = ""+mailf.getReplyTo();
    AddressFormat[] toAF = mailf.getTo();
    AddressFormat[] ccAF = mailf.getCc();
    AddressFormat[] bccAF = mailf.getBcc();
    
    String to = "";
    for (int i=0; i<toAF.length-1; i++)
      to += toAF[i] + ", ";
    if (toAF.length != 0)
      to += toAF[toAF.length-1];
    
    String cc = "";
    for (int i=0; i<ccAF.length-1; i++)
      cc += ccAF[i] + ", ";
    if (ccAF.length != 0)
      cc += ccAF[ccAF.length-1];
    
    String bcc = "";
    for (int i=0; i<bccAF.length-1; i++)
      bcc += bccAF[i] + ", ";
    if (bccAF.length != 0)
      bcc += bccAF[bccAF.length-1];
    
    Vector headerVector = new Vector();
    header = "Date: " + date + "\n" + "From: " + from + "\n";
    headerVector.addElement("Date: " + date);
    headerVector.addElement("From: " + from);
    if(!to.equals("")) {
      header += "To: " + to + "\n";
      headerVector.addElement("To: " + to);
    }
    if(!cc.equals("")) {
      header += "Cc: " + cc + "\n";
      headerVector.addElement("Cc: " + cc);
    }
    if(!sub.equals("")) {
      header += "Subject: " + sub + "\n";
      headerVector.addElement("Subject: " + sub);
    }
    
    head = new String[headerVector.size()];
    headerVector.copyInto(head);
    //for(int l=0; l<head.length; l++) System.out.println("fillHead() header in server :"+head[l]);
    headLock = false;
  }

  synchronized void fillBody() {	    
    bodyLock = true;
    StringBuffer sbuf = new StringBuffer();
    msg = mailf.getMessageBody();
    for(int i = 0; i < msg.length; i++) 
      sbuf.append(msg[i]+"\n");
    body = sbuf.toString();
    bodyLock = false;
  }
	    

  public void run() {
    String inline="";
    boolean imageFound = false;
    boolean logoFound = false;
    String folderName = "";

    send_folder_names();
    process_index();
      
      try {
	for(;;) {
	  inline = in.readLine();
	  System.out.println("read no." + inline);
	  if(inline.startsWith("GETFOLDER ")) {
	    String folder = inline.substring("GETFOLDER ".length());
	    out.println("GETFOLDER");
	    fsc = new FolderParser("furma", "postoffice.npac.syr.edu", "/home/B8F/furma/mail", folder); 
	    FolderName = folder;
	    indexf = fsc.index();
	    send_folder_names();
	    process_index();
	  }
	  else if(inline.startsWith("FOLDERNAME ")) {
	    folderName = inline.substring("FOLDERNAME ".length());
	  }
	  else if(inline.startsWith("SAVE ")) {
	    int mail_num = Integer.parseInt(inline.substring("SAVE ".length()));
	    try {
	      fsc.save(mail_num, "/home/B8F/furma/mail/", folderName);
	    } catch (NoSuchFolderException nsfe) {
	      try {
		RandomAccessFile newFolder = new RandomAccessFile("/home/B8F/furma/mail/"+folderName, "rw");
		newFolder.close();
		try {
		  fsc.save(mail_num, "/home/B8F/furma/mail/", folderName);
		} catch (NoSuchFolderException nsfex) {;}
	      } catch (IOException ioex) {;}
	    }
	  }
	  else if(inline.startsWith("UNDELETE ")) {
	    int mail_number = Integer.parseInt(inline.substring("UNDELETE ".length()));
	    fsc.delete(mail_number,false);
	  }
	  else if(inline.startsWith("SENDMAIL ")) {
	    int bodyLength = Integer.parseInt(inline.substring("SENDMAIL {".length(),inline.indexOf('}')));
	    String toSend = inline.substring(inline.indexOf('}')+2);
	    String s = "";
	    for( ; s.length() < bodyLength ;) 
	      s += in.readLine() + "\n";
	    
	    SendMail sm = new SendMail (toSend, s);
	    sm.sendMessage();
	  }
	  else if(inline.startsWith("DELETE ")) {
	    int mail_number = Integer.parseInt(inline.substring("DELETE ".length()));
	    fsc.delete(mail_number,true);
	  }
	  else if(inline.startsWith("UNDELETE ")) {
	    int mail_number = Integer.parseInt(inline.substring("UNDELETE ".length()));
	    fsc.delete(mail_number,false);
	  }
	  else if(inline.startsWith("EXPUNGE")) {
	    fsc.expunge(); 
	    fsc.selectMailbox("INBOX");
	    indexf = fsc.index();
	    out.println("EXPUNGE");
	    System.out.println("EXPUNGE");
	    process_index();
	  }
	  else if (inline.startsWith("MAILNO ")) {
	    int mail_no = Integer.parseInt(inline.substring("MAILNO ".length()));
	    date = indexf.getDate(mail_no-1);
	    sub = indexf.getSubject(mail_no-1);
	    
	    mailf = fsc.body(mail_no);

	    from = mailf.getFrom().toString();
	    
	    String personalName = mailf.getFrom().getMailboxName();
	    imageFound = false;
	    senderName = personalName;
	    System.out.println("INBOX sender is: " +senderName);
	    for(int p =0; p < name_array.length; p++) {
	      if (name_array[p].equals(personalName)) {
		System.out.println("INBOX name matched to: " + personalName);
		senderGif = personalName;
		imageFound = true;
	      }
	    }
	    if(!imageFound) {
	      imageFound = false;
	      senderGif = "no_img";
	    }
	    
	    String hostName = mailf.getFrom().getHostName();
	    logoFound = false;
	    StringTokenizer st = new StringTokenizer(hostName,".");
	    String str = "";

	    while(st.hasMoreTokens()) {
	      str = st.nextToken();
	      for(int q = 0; q < logo_array.length && !logoFound; q++) {
		if (logo_array[q].equals(str)) {
		  logoFound = true;
		  logoName = str;
		  logoGif = str;
		}
	      }
	    }
	    if(!logoFound) {
	      logoFound = false;
	      logoGif =  "no_img";
	      logoName = str;
	    }  
	    
	    fillHead();
	    fillBody();
	    
	    out.println ( header + "{" + body.length() + "}\n\n" + body );
	  }
	}
      }
      catch (IOException e) {;}
  }   // end of run() function
}
 


